/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "DvObj.h"
#include "qplug_if.h"

extern "C" QplugReturnStatus DvQarDOTPROD(vector<DvObject_var>&, vector<DvObject_var>&);

QplugReturnStatus DvQarDOTPROD(vector<DvObject_var>& inputs, vector<DvObject_var>& outputs)
{
	QplugReturnStatus	status;
	int qar_status;


	DvObject_var in1_ptr;
	DvObject_var in2_ptr;
	DvObject_var out_ptr;

	DvString out_name;

	status = QPLUG_SUCCESS;


	//	Unpack the input data objects

	in1_ptr = inputs[0];
	in2_ptr = inputs[1];

	// Get name of output object

	out_name = GetSlotText(0);
 	if (out_name.empty()) {
    	out_name = "dot";
    	SetSlotText(0, out_name.c_str());
	}
  

	// do arithmetic...


	out_ptr = in1_ptr->dot(in2_ptr);


	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );

	outputs.push_back(out_ptr);

	QplugAppendTextDisplay ("Dot Product: Done\n");
  
	return status;

}

