/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "DvObj.h"
#include "qplug_if.h"

extern "C" QplugReturnStatus DvQarMULTIPLY(vector <DvObject_var>&, vector <DvObject_var>&);

QplugReturnStatus DvQarMULTIPLY(vector <DvObject_var>& inputs, vector <DvObject_var>& outputs)
{
	QplugReturnStatus	status;

	DvObject_var in1_ptr;
	DvObject_var in2_ptr;
	DvObject_var  out_ptr;

	DvString out_name;

	status = QPLUG_SUCCESS;

	if(inputs.size() < 2) {
    	QplugAppendTextDisplay ("Arithmetic>> This Operation requires 2 inputs\n");
    	return QPLUG_FAILURE; 
	} 

	//	Unpack the input data objects

	in1_ptr = inputs[0];
	in2_ptr = inputs[1];


	// Get name of output object

 	out_name = GetSlotText(0);
 	if ( out_name.empty() ) {
    	out_name = "Sum";
    	SetSlotText(0, out_name.c_str());
 	}
  

	// do arithmetic...

	out_ptr = in1_ptr * in2_ptr;

	if ( out_ptr.is_nil() ) {
    	QplugAppendTextDisplay ("Arithmetic>> Multiply not yet supported between these types\n");
    	return QPLUG_FAILURE; 
	}
 
	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );

	//	..add  the output series to the list

	outputs.push_back(out_ptr);

	QplugAppendTextDisplay ("Multiply: Done\n");
  
	return status;

}

