#include "qcalcEvaluator.h"


void QEvaluatorPow::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;

	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	if(val2->arraySize() > 1)
	{
		message=QString("cannot raise to power of vector or array");
		ok=false;
		return;
	}
	if(val2->seqSize() > 1)
	{
		message=QString("cannot raise to power of sequence");
		ok=false;
		return;
	}
	
	if(val2->hasUnits())
	{
		// issue warning
		message=QString("WARNING! Operation Power - Exponent has units.");
		ok=false;
	}
	
	// do arithmetic..

	if(val2->is_dbl()) result = val1->power( val2->dbl(0) );
	else if(val2->is_int()) result = val1->power( val2->itg(0) );


	out[0]->setValue(result, true);
}
