#include "qcalcEvaluator.h"


void QEvaluatorUnits::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
		
	DvString SIcTarget;
	
	if(val2->is_str())
	{
		SIcTarget = val2->str(); 
	}
	else
	{
		SIcTarget = val2->getXrefText("SI_conversion");
	}


	if(SIcTarget.empty())
	{
		message=QString("Cannot get SI_conversion target for Unit Conversion\n" );
		ok=false;
		return;
	}

	DvString Units = val2->getXrefText("Units");

	result = val1->changeUnitsTo(SIcTarget, Units);
 
	if ( result.is_nil() )
	{
		message=QString("Cannot convert object to chosen target units\n RHS of target SI_conversion should be of form ...\n");
		DvString attrPtr = val1->getXrefText(SI_CONVERSION);
		message+=QString(attrPtr.after('>').c_str());
		ok=false;
		return;
	}
  
	out[0]->setValue(result, true);
}
