#ifndef QCC_WINDOW_H
#define QCC_WINDOW_H

#include "qdutil.h"
#include "qrtn.h"
#include "QtPLWidget.h"

#include <QSlider>
#include <QComboBox>
#include <QLabel>
#include <QLayout>
#include <QLineEdit>
#include <QPushButton>
#include <QMainWindow>
#include <QFileDialog>
#include <QValidator>
#include <QAction>
#include <QMenuBar>
#include <QPrintDialog>
#include <QGroupBox>
#include <QObject>
#include <QCheckBox>


#include "PlotWindow.h"
#include "qplug_if.h"
#include "qtpl.h"

// QClusterConfig Window

class PlugPlotWidgets : public QGroupBox
{
	Q_OBJECT

	public:
		
		PlugPlotWidgets(PlotWindow *_win);
        ~PlugPlotWidgets(){;}
		
		void setParameters(RtnVector& v1, RtnVector& v2, RtnVector& v3, RtnVector& v4, const QString& title, const QString& frame);
    
        PlotWindow *win;
        QSlider *sliderAlt;
        QSlider *sliderAz;
	
	public slots:
		
		void altChanged(int);
		void azChanged(int);
		
		void projXChanged(int);
		void projYChanged(int);
		void projZChanged(int);
		
		void newX1(const QString&);
		void newY1(const QString&);
		void newZ1(const QString&);
		
		void newX2(const QString&);
		void newY2(const QString&);
		void newZ2(const QString&);
		
		void newX3(const QString&);
		void newY3(const QString&);
		void newZ3(const QString&);
		
		void newX4(const QString&);
		void newY4(const QString&);
		void newZ4(const QString&);
		
		void newTitle(const QString&);
		void newFrame(const QString&);
		
		void changeColour1();
		void changeColour2();
		void changeColour3();
		void changeColour4();
		void changeColourBg();

    
	protected:
		
		int getColourIndex(const QColor& c);
		
		void resetColourIndex();
		
		void replot();
		
		QtPLWidget * plot;
		
		struct
		{
			double position[3];
			QColor colour;
		}
		clusterParameters[4];
		
		bool projection[3];
		
		double alt, az;
		
		QColor bgColour;
		
		//TODO add time

		PLINT strm;

		
		QPushButton * buttonCol1, *buttonCol2, *buttonCol3, *buttonCol4, *buttonBgColour;
		QCheckBox* projX, *projY, *projZ;
		QLineEdit* editTitle;
		QLineEdit* editAxis;
		QLineEdit* editX1, *editY1, *editZ1,
  				*editX2, *editY2, *editZ2,
      				*editX3, *editY3, *editZ3,
	  			*editX4, *editY4, *editZ4;
				
		vector <int> userR;
		vector <int> userG;
		vector <int> userB;
		
		QString title;
		QString frame;
};
#endif