/* calcps.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "f2c.h"
#include "stdio.h"

/* Table of constant values */

static integer c__1 = 1;
static doublereal c_b8 = 360.;


/* Subroutine */ int calcps_(integer *iyr, integer *iday, integer *ihour, 
	integer *min__, integer *isec, real *psi)
{


    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal), cos(doublereal), sin(doublereal), asin(
	    doublereal);

    /* Local variables */
    static real sdec, ctcl, cgst, stcl, ctsl, sgst, stsl, t, y, obliq, slong, 
	    f1, f2, srasn, s1, s2, s3, y1, y2, y3, z1, z2, z3, g10, g11, h11, 
	    dj, hi, dt;
    static integer iy;
    static real sq, cl0, ct0, dy1, sl0, dz1, dz2, dz3, dy2, dy3, st0;
    static integer ide;
    static real chi, shi;
    static integer iye;
    static real cps;
    static integer ipr;
    static real gst, sqq, sqr;
    extern /* Subroutine */ int sun_(integer *, integer *, integer *, integer 
	    *, integer *, real *, real *, real *, real *);
    static real sps, dip1, dip2, dip3;







/* -----INPUT PARAMETERS: */

/*     IYR   -  YEAR NUMBER (FOUR DIGITS) */
/*     IDAY  -  DAY OF YEAR (DAY 1 = JAN 1) */
/*     IHOUR -  HOUR OF DAY (00 TO 23) */
/*     MIN   -  MINUTE OF HOUR (00 TO 59) */
/*     ISEC  -  SECONDS OF MINUTE (00 TO 59) */

/* -----OUTPUT PARAMETERS:   PSI - THE GEODIPOLE TILT ANGLE PS (RADIANS) */

/*    OTHER SUBROUTINES CALLED BY THIS ONE: SUN */

/*   ################################################ */
/*   #  WRITTEN BY  N.A. TSYGANENKO ON DEC.1, 1991  # */
/*   ################################################ */

/*    Last modification:  January 5, 2001. */
/*    The code has been modified to accept dates through 2005. */
/*    Also, a "save" statement was added, to avoid potential problems */
/*    with some Fortran compilers. */

    iy = *iyr;
    ide = *iday;
    if (iy < 1965) {
	iy = 1965;
    }
    if (iy > 2005) {
	iy = 2005;
    }

/*  WE ARE RESTRICTED BY THE INTERVAL 1965-2005, */
/*  FOR WHICH THE IGRF COEFFICIENTS ARE KNOWN; IF IYR IS OUTSIDE THIS INTERVAL */
/*  THE SUBROUTINE PRINTS A WARNING (BUT DOES NOT REPEAT IT AT NEXT INVOCATIONS) */

    if (iy != *iyr && ipr == 0) {
		printf("(\n****CALCPS WARNS:  YEAR IS OUT OF INTERVAL 1965-2005: IYR=%d\n CALCULATIONS WILL BE DONE FOR IYR=%d)", (int)*iyr, (int)iy);
    }
    if (iy != *iyr) {
	ipr = 1;
    }
    iye = iy;

/*  LINEAR INTERPOLATION OF THE GEODIPOLE MOMENT COMPONENTS BETWEEN THE */
/*  VALUES FOR THE NEAREST EPOCHS: */

    if (iy < 1970) {
/* 1965-1970 */
	f2 = ((real) iy + (real) (*iday) / (float)365. - (float)1965.) / (
		float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)30334. + f2 * (float)30220.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-2119. - f2 * (float)2068.;
	h11 = f1 * (float)5776. + f2 * (float)5737.;
    } else if (iy < 1975) {
/* 1970-1975 */
	f2 = ((real) iy + (real) (*iday) / (float)365. - (float)1970.) / (
		float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)30220. + f2 * (float)30100.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-2068. - f2 * (float)2013.;
	h11 = f1 * (float)5737. + f2 * (float)5675.;
    } else if (iy < 1980) {
/* 1975-1980 */
	f2 = ((doublereal) iy + (doublereal) (*iday) / (float)365. - (float)
		1975.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)30100. + f2 * (float)29992.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-2013. - f2 * (float)1956.;
	h11 = f1 * (float)5675. + f2 * (float)5604.;
    } else if (iy < 1985) {
/* 1980-1985 */
	f2 = ((real) iy + (real) (*iday) / (float)365. - (float)1980.) / (
		float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29992. + f2 * (float)29873.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1956. - f2 * (float)1905.;
	h11 = f1 * (float)5604. + f2 * (float)5500.;
    } else if (iy < 1990) {
/* 1985-1990 */
	f2 = ((real) iy + (real) (*iday) / (float)365. - (float)1985.) / (
		float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29873. + f2 * (float)29775.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1905. - f2 * (float)1848.;
	h11 = f1 * (float)5500. + f2 * (float)5406.;
    } else if (iy < 1995) {
/* 1990-1995 */
	f2 = ((real) iy + (real) (*iday) / (float)365. - (float)1990.) / (
		float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29775. + f2 * (float)29682.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1848. - f2 * (float)1789.;
	h11 = f1 * (float)5406. + f2 * (float)5318.;
    } else if (iy < 2000) {
/* 1995-2000 */
	f2 = ((real) iy + (real) (*iday) / (float)365. - (float)1990.) / (
		float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29682. + f2 * (float)29615.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1789. - f2 * (float)1728.;
	h11 = f1 * (float)5318. + f2 * (float)5186.;
    } else {

/*   LINEAR EXTRAPOLATION BEYOND 2000 BY USING SECULAR VELOCITY COEFFICIENTS: */

/* 2000-2005 */
	dt = (real) iy + (real) (*iday) / (float)366. - (float)2e3;
	g10 = (float)29615. - dt * (float)14.6;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = dt * (float)10.7 - (float)1728.;
	h11 = (float)5186. - dt * (float)22.5;
    }

/*  NOW CALCULATE THE COMPONENTS OF THE UNIT VECTOR EzMAG IN GEO COORD.SYSTEM: */
/*   SIN(TETA0)*COS(LAMBDA0), SIN(TETA0)*SIN(LAMBDA0), AND COS(TETA0) */
/*         ST0 * CL0                ST0 * SL0                CT0 */

/* Computing 2nd power */
    r__1 = g11;
/* Computing 2nd power */
    r__2 = h11;
    sq = r__1 * r__1 + r__2 * r__2;
    sqq = sqrt(sq);
/* Computing 2nd power */
    r__1 = g10;
    sqr = sqrt(r__1 * r__1 + sq);
    sl0 = -h11 / sqq;
    cl0 = -g11 / sqq;
    st0 = sqq / sqr;
    ct0 = g10 / sqr;
    stcl = st0 * cl0;
    stsl = st0 * sl0;
    ctsl = ct0 * sl0;
    ctcl = ct0 * cl0;

/*      THE CALCULATIONS ARE TERMINATED IF ONLY GEO-MAG TRANSFORMATION */
/*       IS TO BE DONE  (IHOUR>24 IS THE AGREED INDICATOR FOR THIS CASE): */

/* L5: */
    if (*ihour > 24) {
	return 0;
    }

    sun_(&iy, iday, ihour, min__, isec, &gst, &slong, &srasn, &sdec);

/*  S1,S2, AND S3 ARE THE COMPONENTS OF THE UNIT VECTOR EXGSM=EXGSE IN THE */
/*   SYSTEM GEI POINTING FROM THE EARTH'S CENTER TO THE SUN: */

    s1 = cos(srasn) * cos(sdec);
    s2 = sin(srasn) * cos(sdec);
    s3 = sin(sdec);
    cgst = cos(gst);
    sgst = sin(gst);

/*  DIP1, DIP2, AND DIP3 ARE THE COMPONENTS OF THE UNIT VECTOR EZSM=EZMAG */
/*   IN THE SYSTEM GEI: */

    dip1 = stcl * cgst - stsl * sgst;
    dip2 = stcl * sgst + stsl * cgst;
    dip3 = ct0;

/*  NOW CALCULATE THE COMPONENTS OF THE UNIT VECTOR EYGSM IN THE SYSTEM GEI */
/*   BY TAKING THE VECTOR PRODUCT D x S AND NORMALIZING IT TO UNIT LENGTH: */

    y1 = dip2 * s3 - dip3 * s2;
    y2 = dip3 * s1 - dip1 * s3;
    y3 = dip1 * s2 - dip2 * s1;
    y = sqrt(y1 * y1 + y2 * y2 + y3 * y3);
    y1 /= y;
    y2 /= y;
    y3 /= y;

/*   THEN IN THE GEI SYSTEM THE UNIT VECTOR Z = EZGSM = EXGSM x EYGSM = S x Y */
/*    HAS THE COMPONENTS: */

    z1 = s2 * y3 - s3 * y2;
    z2 = s3 * y1 - s1 * y3;
    z3 = s1 * y2 - s2 * y1;

/*    THE VECTOR EZGSE (HERE DZ) IN GEI HAS THE COMPONENTS (0,-SIN(DELTA), */
/*     COS(DELTA)) = (0.,-0.397823,0.917462); HERE DELTA = 23.44214 DEG FOR */
/*   THE EPOCH 1978 (SEE THE BOOK BY GUREVICH OR OTHER ASTRONOMICAL HANDBOOKS). */
/*    HERE THE MOST ACCURATE TIME-DEPENDENT FORMULA IS USED: */

    dj = (real) ((iy - 1900) * 365 + (iy - 1901) / 4 + *iday) - (float).5 + (
	    real) (*ihour * 3600 + *min__ * 60 + *isec) / (float)86400.;
    t = dj / (float)36525.;
    obliq = ((float)23.45229 - t * (float).0130125) / (float)57.2957795;
    dz1 = (float)0.;
    dz2 = -sin(obliq);
    dz3 = cos(obliq);

/*  THEN THE UNIT VECTOR EYGSE IN GEI SYSTEM IS THE VECTOR PRODUCT DZ x S : */

    dy1 = dz2 * s3 - dz3 * s2;
    dy2 = dz3 * s1 - dz1 * s3;
    dy3 = dz1 * s2 - dz2 * s1;

/*   THE ELEMENTS OF THE MATRIX GSE TO GSM ARE THE SCALAR PRODUCTS: */
/*   CHI=EM22=(EYGSM,EYGSE), SHI=EM23=(EYGSM,EZGSE), EM32=(EZGSM,EYGSE)=-EM23, */
/*     AND EM33=(EZGSM,EZGSE)=EM22 */

    chi = y1 * dy1 + y2 * dy2 + y3 * dy3;
    shi = y1 * dz1 + y2 * dz2 + y3 * dz3;
    hi = asin(shi);

/*    TILT ANGLE: PSI=ARCSIN(DIP,EXGSM) */

    sps = dip1 * s1 + dip2 * s2 + dip3 * s3;
/* Computing 2nd power */
    r__1 = sps;
    cps = sqrt((float)1. - r__1 * r__1);
    *psi = asin(sps);

    return 0;
} /* calcps_ */

#ifdef __cplusplus
	}
#endif


