#include "qwui.h"
#include "DvObj.h"

#include <stdio.h>


void  setStandardConstants(){

 // pi
 // _____________
 
	double pi_value = (double)  4.0 *atan(1.0);
	DvObject_var pi  = new DvObject(pi_value);

	QwuiPutOnWL(pi,  "Constants/pi");
 
  // SI_conversion

   // don't set so that value can be used with anything

 // FIELDNAM
	pi->change_xref( FIELDNAM, "Value of pi");
 
 // Frame
	pi->change_xref( FRAME, "scalar>na");
  
 // UNITS
	pi->change_xref( UNITS, " ");

    
// deg 2 rad
//-----------
  double d2r_value = pi_value / 180.;
  DvObject_var d2r = new DvObject( d2r_value);
  QwuiPutOnWL(d2r, "Constants/deg2rad"); 
   
	// SI_conversion
	d2r->change_xref(SI_CONVERSION, "1>radian degree^-1");

	// FIELDNAM
	d2r->change_xref(FIELDNAM, "Degree to Radian" );
 
	// Frame
	d2r->change_xref( FRAME, "scalar>na");
  
	// UNITS
	d2r->change_xref(UNITS, "rad / deg");

    
	double r2d_value = 180. / pi_value; 
	DvObject_var r2d = new DvObject(r2d_value);
	QwuiPutOnWL(r2d, "Constants/rad2deg");
  
	// SI_conversion
	r2d->change_xref(SI_CONVERSION, "1> degree radian^-1" );

	// FIELDNAM
	r2d->change_xref(FIELDNAM, "Radian to Degree" );
 
	// Frame
	r2d->change_xref( FRAME, "scalar>na");
  
	// UNITS
	r2d->change_xref(UNITS, "deg/rad");
 


  // e
  // _____________
 
	double e_value = (double)  exp(1.0);
    
	DvObject_var e = new DvObject( e_value);

	QwuiPutOnWL( e, "Constants/e");

	// SI_conversion

	// don't set so that value can be used with anything

	// FIELDNAM
	e->change_xref(FIELDNAM, "Value of e = exp(1)" );
 
	// Frame
	e->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	e->change_xref(UNITS, " " );
 

  // Mu_0
  // _____________
 
	double Mu0_value = (double)  1.256637e-6;
    
	DvObject_var Mu0 = new DvObject(Mu0_value);

	QwuiPutOnWL(Mu0, "Constants/Mu_0"); 

	// SI_conversion
	Mu0->change_xref(SI_CONVERSION, "1>H m^-1" );

	// FIELDNAM
	Mu0->change_xref(FIELDNAM, "Permeability of free space" );
 
	// Frame
	Mu0->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	Mu0->change_xref( UNITS, "H/m" );
 

  // Epsilon_0
  // _____________
 
	double Eps0_value = (double)  8.85416e-12;
    
	DvObject_var Eps0 = new DvObject( Eps0_value);

	QwuiPutOnWL(Eps0, "Constants/Epsilon_0"); 
   
	// SI_conversion
	Eps0->change_xref( SI_CONVERSION, "1>F m^-1" );

	// FIELDNAM
	Eps0->change_xref( FIELDNAM, "Permittivity of free space" );
 
	// Frame
	Eps0->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	Eps0->change_xref( UNITS, "F/m" );
 
 
  // Electron Charge
  // _____________
 
	double q_e_value = (double)  1.60210e-19;
    
	DvObject_var q_e = new DvObject( q_e_value);

	QwuiPutOnWL(q_e, "Constants/q_e");
 
	// SI_conversion
	q_e->change_xref(SI_CONVERSION, "1>C" );

	// FIELDNAM
	q_e->change_xref(FIELDNAM, "Electron charge" );
 
	// Frame
	q_e->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	q_e->change_xref(UNITS, "C" );


 // Speed of light
 // _____________
 
	double c_value = (double)  2.997925e8;
    
	DvObject_var c = new DvObject(c_value);

	QwuiPutOnWL(c, "Constants/c");
 
	// SI_conversion
	c->change_xref(SI_CONVERSION, "1>m s^-1" );

	// FIELDNAM
	c->change_xref(FIELDNAM, "speed of light" );
 
	// Frame
	c->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	c->change_xref(UNITS, "m/s" );
 

 // electron mass
 // _____________
 
	double m_e_value = (double)  9.1091e-31;
    
	DvObject_var m_e = new DvObject(m_e_value);

	QwuiPutOnWL(m_e, "Constants/m_e");
  
	// SI_conversion
	m_e->change_xref(SI_CONVERSION, "1>kg" );

	// FIELDNAM
	m_e->change_xref(FIELDNAM, "mass of electron" );
 
	// Frame
	m_e->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	m_e->change_xref(UNITS, "kg" );
 
 
  //  proton mass
  // _____________
 
	double m_p_value = (double)  1.67e-27;
    
	DvObject_var m_p = new DvObject(m_p_value);

	QwuiPutOnWL(m_p, "Constants/m_p");
 
	// SI_conversion
	m_p->change_xref(SI_CONVERSION, "1>kg" );

	// FIELDNAM
	m_p->change_xref(FIELDNAM, "mass of proton" );
 
	// Frame
	m_p->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	m_p->change_xref(UNITS, "kg" );
 

  //  Boltzman's constant
  // _____________
 
	double k_value = (double)  1.38054e-23;
    
	DvObject_var k = new DvObject( k_value);

	QwuiPutOnWL(k, "Constants/k");
 
	// SI_conversion
	k->change_xref(SI_CONVERSION, "1>J K^-1" );

	// FIELDNAM
	k->change_xref(FIELDNAM, "Boltzman's constant" );
 
	// Frame
	k->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	k->change_xref(UNITS, "J/K" );


  //  Earth Radius
  // _____________
 
	double Re_value = (double)  6.3712e6;
    
	DvObject_var Re = new DvObject( Re_value);

	QwuiPutOnWL(Re, "Constants/Re");
 
	// SI_conversion
	Re->change_xref(SI_CONVERSION, "1>m" );

	// FIELDNAM
	Re->change_xref(FIELDNAM, "Earth Eq radius" );
 
	// Frame
	Re->change_xref(FRAME, "scalar>na" );
  
	// UNITS
	Re->change_xref(UNITS, "m" );
 

  //  Astronomical Unit
  // _____________
 
	double au_value = (double)  1.495985e11;
    
	DvObject_var au = new DvObject( au_value);

	QwuiPutOnWL(au, "Constants/au");
  
	// SI_conversion
	au->change_xref(SI_CONVERSION, "1>m" );

	// FIELDNAM
	au->change_xref(FIELDNAM, "Astronomical Unit" );
 
	// Frame
	au->change_xref( FRAME, "scalar>na" );
  
	// UNITS
	au->change_xref(UNITS, "m" );
 

  // unit vectors
  // _____________

// This is a cartesian vector so must be a matrix object = (1, 0, 0)
	valarray <double> v(3);
	vector <size_t> d;
	d.push_back(3);
	v[0] = 1.0;
	v[1] = 0.0;
	v[2] = 0.0;
	DvObject_var x_axis =  new DvObject( v, d);
	QwuiPutOnWL(x_axis, "Constants/Ix");

	v[0] = 0.0;
	v[1] = 1.0;
	v[2] = 0.0;
	DvObject_var y_axis =  new DvObject( v, d);
	QwuiPutOnWL(y_axis, "Constants/Iy");

	v[0] = 0.0;
	v[1] = 0.0;
	v[2] = 1.0;
	DvObject_var z_axis =  new DvObject( v, d);
	QwuiPutOnWL(z_axis, "Constants/Iz");

	// SI_conversion
    // don't set so that unit vectors can be used with anything

	// FIELDNAM
	x_axis->change_xref(FIELDNAM, "unit vector (1,0,0)" );
	y_axis->change_xref(FIELDNAM, "unit vector (0,1,0)" );
	z_axis->change_xref(FIELDNAM, "unit vector (0,0,1)" );

	// Frame
	x_axis->change_xref( FRAME, "vector>any_xyz");
	y_axis->change_xref( FRAME, "vector>any_xyz");
	z_axis->change_xref( FRAME, "vector>any_xyz");
 

} // end setStandardConstants

