#include "qpui.h"
#include "qbu.h"

extern QPalette QPUI_normal_palette;
extern int qsas_restore_release;

int importedPaletteOffset;

// ---------------- 

// Icons for list view
 
 static const char * page_xpm[] = {
  "12 16 4 1",
  " 	c None",
  "X	c #A0A0A0",
  ".	c #FFFFFF",
  "#	c #E0E0E0",
  "            ",
  " XXXXXX     ",
  " X....XX    ",
  " X....X.X   ",
  " X....XXXX# ",
  " X.......X# ",
  " X.......X# ",
  " X.......X# ",
  " X.......X# ",
  " X.......X# ",
  " X.......X# ",
  " X.......X# ",
  " X.......X# ",
  " XXXXXXXXX# ",
  "  ######### ",
  "            "};
  
static const char * frame_xpm[] = {
   "12 16 4 1",
   " 	c None",
   "X	c #A0A0A0",
   ".	c #FFFFFF",
   "#	c #E0E0E0",
   "            ",
   "   X X  X   ",
   "  XXXX XXX  ",
   "            ",
   " XXXXXXXXX  ",
   " X.......X# ",
   " X.......X# ",
   " XXXXXXXXX# ",
   " X.......X# ",
   " X.......X# ",
   " XXXXXXXXX# ",
   " X.......X# ",
   " X.......X# ",
   " XXXXXXXXX# ",
   "  ######### ",
   "            "};

static const char * panel_xpm[] = {
    "12 16 6 1",
    " 	c None",
    "X	c #A0A0A0",
    ".	c #FFFFFF",
    "1	c #FF4040",
    "2	c #40B040",
    "#	c #E0E0E0",
    "            ",
    " XXXXXXXXX  ",
    " X.......X# ",
    " X.......X# ",
    " XX.2...XX# ",
    " X.222...X# ",
    " X22.2221X# ",
    " XX...21XX# ",
    " X....11.X# ",
    " X..111..X# ",
    " XX111..XX# ",
    " X11.....X# ",
    " X1......X# ",
    " XXXXXXXXX# ",
    "  ######### ",
    "            "};
    
static const char * constxt_xpm[] = {
     "12 16 4 1",
     " 	c None",
     "X	c #FF7070",
     ".	c #FFFFFF",
     "#	c #DF5050",
     "            ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     " ....X....  ",
     "            "};
     
static const char * consty_xpm[] = {
      "12 16 4 1",
      " 	c None",
      "X	c #FF7070",
      ".	c #FFFFFF",
      "#	c #DF5050",
      "            ",
      " .......... ",
      " .......... ",
      " .......... ",
      " .......... ",
      " .......... ",
      " .......... ",
      " XXXXXXXXXX ",
      " .......... ",
      " .......... ",
      " .......... ",
      " .......... ",
      " .......... ",
      " .......... ",
      "            ",
      "            "};
      
static const char * trace_xpm[] = {
       "12 16 4 1",
       " 	c None",
       "X	c #FF7070",
       ".	c #FFFFFF",
       "#	c #DF5050",
       "            ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " ..XX...... ",
       " .X..X..... ",
       " X....X.... ",
       " X....X.... ",
       " ......X..X ",
       " .......XX. ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       "            "};

static const char * linear_xpm[] = {
       "12 16 4 1",
       " 	c None",
       "X	c #FF7070",
       ".	c #FFFFFF",
       "#	c #DF5050",
       "            ",
       " .......... ",
       " X......... ",
       " .X........ ",
       " ..X....... ",
       " ...X...... ",
       " ....X..... ",
       " .....X.... ",
       " ......X... ",
       " .......X.. ",
       " ........X. ",
       " .........X ",
       " .......... ",
       " .......... ",
       " .......... ",
       "            "};

static const char * TLabel_xpm[] = {
       "12 16 4 1",
       " 	c None",
       "X	c #A0A0A0",
       ".	c #FFFFFF",
       "#	c #DF5050",
       "            ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " .......... ",
       " X........X ",
       " X..X..X..X ",
       " X..X..X..X ",
       " XXXXXXXXXX ",
       " .......... ",
       "            "};

  
  static const char * spectrum_xpm[] = {
   "12 16 6 1",
   " 	c None",
   "D	c #0178FE",
   "B	c #17DEDE",
   ".	c #40FE35",
   "Y	c #E9F500",
   "R	c #FF5218",
   "            ",
   " DDDDBDDDBD ",
   " DBDBDBDDDB ",
   " BBBDBBBDBB ",
   " .BBB.BBB.B ",
   " BBB.BBB.BB ",
   " .B...B...B ",
   " ..Y....Y.. ",
   " Y...Y...Y. ",
   " YY.Y.Y.YYY ",
   " YYYYYYYYRY ",
   " RRYRYRYYYR ",
   " RRRYRYRYRR ",
   " RYRRRRYRRR ",
   " RRRRRRRRRR ",
   "            "};
 
 static const char * event_xpm[] = {
  "12 16 4 1",
  " 	c None",
  "X	c #A0A0A0",
  ".	c #FFFFFF",
  "#	c #E0E0E0",
  "            ",
  " XXXXXXXXX  ",
  " X.......X# ",
  " X..XXX..X# ",
  " X..X....X# ",
  " X..XX...X# ",
  " X..X....X# ",
  " X..XXX..X# ",
  " X.......X# ",
  " XXXXXXXXX# ",
  "  ###X##### ",
  "     X#     ",
  "     X#     ",
  "     X#     ",
  "      #     ",
  "            "};
       



//--------------------------------------

////// QpuiItem class
//--------------------------------------

QpuiItem::QpuiItem(const QString& name, QpuiItem* parent): QTreeWidgetItem((QTreeWidgetItem*) parent)
{
	setText(0, name);	    
	setText(1, "");	 
	this->setFlags(Qt::ItemIsSelectable | Qt::ItemIsEnabled | Qt::ItemIsDragEnabled | Qt::ItemIsEditable);
	userSetName = false;
}

//----------------

QpuiItem::QpuiItem(const QString& name, PlotList* parent): QTreeWidgetItem((QTreeWidget*) parent)
{
	setText(0, name);	    
	setText(1, "");	 
	this->setFlags(Qt::ItemIsSelectable | Qt::ItemIsEnabled | Qt::ItemIsDragEnabled | Qt::ItemIsEditable);
	userSetName = false;
}

//----------------

void QpuiItem::setNextName()
{
	qApp->processEvents();
	
	if(I_Type == QP_TRACE) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Trace %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Trace %1").arg(count+1));
	}
	else if(I_Type == QP_SPECTROGRAM)  {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Spectrum %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Spectrum %1").arg(count+1));
	}
	else if(I_Type == QP_CONST_XT)  {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Const XT %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Const XT %1").arg(count+1));
	} 
	else if(I_Type == QP_CONST_Y) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Const Y %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Const Y %1").arg(count+1));
	}  
	else if(I_Type == QP_EVENT) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Event %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Event %1").arg(count+1));
	} 
	else if(I_Type == QP_PANEL) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Panel %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Panel %1").arg(count+1));
	} 
	else if(I_Type == QP_FRAME) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Frame %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Frame %1").arg(count+1));
	} 
	else if(I_Type == QP_PAGE) {
		int count = this->Tree()->topLevelItemCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Page %1").arg(i+1);
			QpuiItem* item =  (QpuiItem*) this->Tree()->getItemFromPath(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Page %1").arg(count+1));
	}
	else if(I_Type == QP_REG_LINE) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("Reg Line %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("Reg Line %1").arg(count+1));
	} 
	else if(I_Type == QP_T_LAB) {
		int count = this->parent()->childCount();
		for(int i=0; i<count; i++)
		{
			QString name = QString("T Label %1").arg(i+1);
			QpuiItem* item =  parent()->getChildByName(name);
			if(item == NULL || item == this )
			{
				this->setName(name);
				return;
			}
		}	
		this->setName(QString("T Label %1").arg(count+1));
	}
	
}
//----------------

bool QpuiItem::setName(const QString& newName)
{
	// empty name clears user selection
	if(text(0).isEmpty()) userSetName = false;
	
	// don't change user's choice
	if(userSetName) return false;
	
	if(parent() == NULL)
	{
		setText(0, newName);
		return true;
	}
	
	QString tempName(newName);
	for(int i=0; i<parent()->childCount(); i++)
	{
		if(parent()->child(i)->text(0) == tempName) {
			QpuiItem* item =  (QpuiItem*) parent()->child(i);
			if(item != NULL && item != this)
			{
				tempName.append("A");
				this->setName(tempName);
			}
		}
	}
	
	if(tempName != text(0))
	{
		setText(0, tempName);
	}
       
	return true;
}


void QpuiItem::setIcon(QpItemType_e type){

	QIcon icon = QIcon(QPixmap(trace_xpm));
	
	if(type == QP_TRACE) icon = QIcon(QPixmap(trace_xpm));
	else if(type == QP_SPECTROGRAM) icon = QIcon(QPixmap(spectrum_xpm));
	else if(type == QP_CONST_XT) icon = QIcon(QPixmap(constxt_xpm));
	else if(type == QP_CONST_Y) icon = QIcon(QPixmap(consty_xpm));
	else if(type == QP_EVENT) icon = QIcon(QPixmap(event_xpm));
	else if(type == QP_PANEL) icon = QIcon(QPixmap(panel_xpm));
	else if(type == QP_FRAME) icon = QIcon(QPixmap(frame_xpm));
	else if(type == QP_PAGE) icon = QIcon(QPixmap(page_xpm));
	else if(type == QP_REG_LINE) icon = QIcon(QPixmap(linear_xpm));
	else if(type == QP_T_LAB) icon = QIcon(QPixmap(TLabel_xpm));
	
	QTreeWidgetItem::setIcon(0, icon);
}

// ---------------- 

QString QpuiItem::getPath()
{
	QString path;
	QpuiItem *folder = parent();
	
	while(folder != NULL) {
		path.prepend("::");
		path.prepend(folder->getName());
		folder = folder->parent();
	}
	
	path += this->getName();;
	return path;
}
// ---------------- 

void QpuiItem::expandChildren()
{
	Tree()->expandItem(this);
	for(int i=0; i<childCount(); i++){
		((QpuiItem*)this->child(i))->expandChildren();
	}
}

// ---------------- 

int QpuiItem::childNumber()
{
	
	PageItem* _page = dynamic_cast<PageItem*>(this);
	
	if(parent() != NULL) return parent()->indexOfChild(this);
	else if(_page) return Tree()->indexOfTopLevelItem(this);
	else return Tree()->topLevelItemCount();
}

// ---------------- 

QpuiItem* QpuiItem::getChildByName(const QString& name) const
{
	for(int i=0; i<childCount(); i++)
	{
		if(child(i)->text(0) == name) return (QpuiItem*) child(i);
	}

	return NULL;
}


// ---------------- 

bool QpuiItem::ancestorInList(QList <QTreeWidgetItem*> &list){
	for(int i=0; i<list.size(); i++){
		if(this != list.at(i) &&  ((QpuiItem*)list.at(i))->isAncestorOf(this)) return true;
	}
    return false;
}

// ---------------- 

bool QpuiItem::isAncestorOf(QpuiItem* other)
{
	if(this==other) return true;
	
	for(int i=0; i<childCount(); i++)
	{
		if( ((QpuiItem*)child(i))->isAncestorOf(other)) return true;
	}
	return false;
}

// ---------------- 

bool QpuiItem::moveOK(QpuiItem* item)
{
	// move only possible to parent level or below
	
	PageItem* _page = dynamic_cast<PageItem*>(item);
	if(_page) return true;
	
	FrameItem* _frame = dynamic_cast<FrameItem*>(item);
	if(_frame) return true;
	
	PanelItem* _panel = dynamic_cast<PanelItem*>(item);
	if(_panel){
		if(this->frame()) return true;
		else return false;
	}
	
	PlotItem* _plot = dynamic_cast<PlotItem*>(item);
	if(_plot){
		if(this->panel()) return true;
		else return false;
	}
	
	TLabItem* _TLab = dynamic_cast<TLabItem*>(item);
	if(_TLab){
		if(this->panel()) return true;
		else return false;
	}

	return false;
}

// ---------------- 

QpuiItem* QpuiItem::duplicateItem(QpuiItem* parent)
{
	// handle each data type (constructors descend recursively)

	PageItem* _page = dynamic_cast<PageItem*>(this);
	if(_page){
		PageItem *copy = new PageItem(_page, this->Tree());

		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}
	
	FrameItem* _frame = dynamic_cast<FrameItem*>(this);
	if(_frame){
		FrameItem *copy = new FrameItem(_frame, parent->page());
		
		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}

	PanelItem* _panel = dynamic_cast<PanelItem*>(this);
	if(_panel){
		PanelItem *copy = new PanelItem(_panel, parent->frame());
		
		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}

	TraceItem* _trace = dynamic_cast<TraceItem*>(this);
	if(_trace){
		TraceItem *copy = new TraceItem(_trace, parent->panel());
		copy->setDataYObj(_trace->DataTab->_y_data_fld->text());
		copy->setDataXObj(_trace->DataTab->_x_data_fld->text());
		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}
	
	SpectrumItem* _spect = dynamic_cast<SpectrumItem*>(this);
	if(_spect){
		SpectrumItem *copy = new SpectrumItem(_spect, parent->panel());
		copy->setDataZObj(_spect->DataTab->_z_data_fld->text());
		copy->setDataYObj(_spect->DataTab->_y_start_data_fld->text());
		copy->setDataXObj(_spect->DataTab->_x_start_data_fld->text());
		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}
	
	TLabItem* _TLab = dynamic_cast<TLabItem*>(this);
	if(_TLab){
		TLabItem *copy = new TLabItem(_TLab, parent->panel());
		copy->TLabDataTab->_x_data_fld->setText(_TLab->TLabDataTab->_x_data_fld->text());  // set data slot
		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}

	EventItem* _event = dynamic_cast<EventItem*>(this);
	if(_event){
		EventItem *copy = new EventItem(_event, parent->panel());
		copy->setDataYObj(_event->eventTab->_y_data_fld->text());
		copy->setDataXObj(_event->eventTab->_x_data_fld->text());
		qApp->processEvents(); // ensure list is up to date after removing items
		return copy;
	}

	// ensure something
	QpuiItem *copy = new QpuiItem("", parent);
	return copy;
}

// ---------------- 

void QpuiItem::insertItem(QpuiItem* item)
{
	qApp->processEvents(); // ensure list is up to date after removing items
	
	// insert according to object type
				
	PageItem* _page = dynamic_cast<PageItem*>(item);
	FrameItem* _frame = dynamic_cast<FrameItem*>(item);
	PanelItem* _panel = dynamic_cast<PanelItem*>(item);
	PlotItem* _plot = dynamic_cast<PlotItem*>(item);
	TLabItem* _TLab = dynamic_cast<TLabItem*>(item);

	if(_page ){
		if(this->page()) Tree()->insertTopLevelItem(this->page()->childNumber(), _page);
		else {
			Tree()->addTopLevelItem(_page);
			_page->expandChildren();
		}
	}
	if(_frame){
		if(this->frame()) this->page()->insertChild(this->frame()->childNumber(), _frame);
		else if(this->page()) {
			this->page()->insertChild(0, _frame);
			_frame->expandChildren();
		}
	}
	if(_panel){
		if(this->panel()) this->frame()->insertChild(this->panel()->childNumber(), _panel);
		else if(this->frame()) {
			this->frame()->insertChild(0, _panel);
			_panel->expandChildren();
		}
		else {
			FrameItem *frame;
			if(_panel->frame() && _panel->frame()->frameType() == QP_XY) frame = Tree()->makeXYFrameItem(this);
			else frame = Tree()->makeTSFrameItem(this);
			if(frame) frame->insertChild(0, _panel);
		}
	}
	if(_plot){
		PlotItem *thisPlot = dynamic_cast<PlotItem*>(this);
		if(thisPlot) this->panel()->insertChild(this->childNumber(), _plot);
		else if(this->panel()) this->panel()->insertChild(0, _plot);
		else {
			PanelItem *panel = Tree()->makePanelItem(this, "");
			if(panel) panel->insertChild(0, _plot);
		}
	}
	if(_TLab){
		TLabItem *thisTL = dynamic_cast<TLabItem*>(this);
		if(thisTL) this->panel()->insertChild(this->childNumber(), _TLab);
		else if(this->panel()) this->panel()->insertChild(0, _TLab);
		else {
			PanelItem *panel = Tree()->makePanelItem(this, "");
			if(panel) panel->insertChild(0, _TLab);
		}
	}
	
	item->setName(item->getName()); // ensures name is unique at this level
	
	// update number of traces for old and new panel
	if(this->panel()) this->panel()->LegendTab->updateNumTraces();
}
// ---------------- 

void QpuiItem::insertAbove(QpuiItem* item)
{
	QTreeWidgetItem *_parent = this->parent();
	
	if(_parent){
		//this is not page
		_parent->insertChild(this->childNumber(), item);
	}
	else{
		// this is page
		Tree()->insertTopLevelItem(this->childNumber(), item);
	}
	
	Tree()->setCurrentItem(item);
	
	return;
	
}
// ---------------- 

void QpuiItem::insertBelow(QpuiItem* item)
{
	QTreeWidgetItem *_parent = this->parent();
	
	if(_parent){
		//this is not page
		_parent->insertChild(this->childNumber()+1, item);
	}
	else{
		// this is page
		Tree()->insertTopLevelItem(this->childNumber()+1, item);
	}
	
	Tree()->setCurrentItem(item);
	
	return;
	
}

// ---------------- 

int QpuiItem::level()
{
	PageItem *pageItem = dynamic_cast <PageItem*>(this);
	if(pageItem) return QP_PAGE;

	FrameItem *frameItem = dynamic_cast <FrameItem*>(this);
	if(frameItem) return QP_FRAME;
	
	PanelItem *panelItem = dynamic_cast <PanelItem*>(this);
	if(panelItem) return QP_PANEL;
	
	return QP_PLOT;
	
}

// ---------------- 

void QpuiItem::addCustomColourTableTo(ColourTablePalette& palette)
{
    for(int i=0; i<childCount(); i++)
    {
        ((QpuiItem*)child(i))->addCustomColourTableTo(palette);
    }
}

// ---------------- 

void QpuiItem::clear()
{
	while(this->childCount()>0){
		QpuiItem * item = (QpuiItem*) this->child(0);
		this->removeChild(item);
		delete item;
	}
}


// ---------- PlotList class --------	 
  
PlotList::PlotList(QWidget* parent):
	QTreeWidget(parent)
{
	setDragEnabled(true);
	setAcceptDrops(true);
	setDropIndicatorShown(true);
	setUniformRowHeights(true);
	setSelectionMode(QAbstractItemView::ExtendedSelection);
 	
 	copyDoc = new QDomDocument("plotCopy");
	isLink = false; // global available to every DataTab for use in linking
	
	// Set Right Button Menu
	RButtonMenu=new QMenu(this);

	setEditTriggers(QAbstractItemView::NoEditTriggers); // only access through rename menu item
	// double click opens data object
	connect(this, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(openObjectEditor(QTreeWidgetItem *, int)));
	
	LinkNumber=0;	
	I_LastTab = QP_IGNORE_TAB;
	
	isCopy = true;
	itemFromTab = NULL;
    
    plotWindows = new QList<PlotWindow*>;

}

//-------------

PlotList::~PlotList(){
    for (int i=0; i<plotWindows->size(); i++) delete (*plotWindows)[i]; 
    plotWindows->clear();
    
	clear();
}

//-------------

void PlotList::dragEnterEvent(QDragEnterEvent *event)
{
	if(QuSlotDebug()) printf("PlotList::dragEnterEvent\n");

	event->acceptProposedAction();
	emit raiseWindow();

}

//-------------

void PlotList::dragMoveEvent(QDragMoveEvent *event)
{
	
}

//-------------

void PlotList::openObjectEditor(QTreeWidgetItem *qitem, int column)
{
	if(qitem!=NULL)
	{
		QpuiItem *item = (QpuiItem *) qitem;
		DvString name = item->getName().toLatin1().data();
		
		DvObject_var obj = getWLObject(name);
		if(obj.is_nil()) return;
		
		DvObject_var nilObj;
		
        QbuLaunchBrowse(nilObj, this, name.c_str(), obj, name.c_str());
		
	}
}

//-------------

void PlotList::displayMenu(const QPoint& p)
{
	RButtonMenu->clear();
	
	QMenu* subMenu=RButtonMenu->addMenu("New");
	subMenu->addAction("Trace", this, SLOT(makeTraceItem()));
	subMenu->addAction("Spectrogram", this, SLOT(makeSpectrumItem()));
	subMenu->addSeparator();
	subMenu->addAction("Constant X or T Trace", this, SLOT(makeConstXTraceItem()));
	subMenu->addAction("Constant Y Trace", this, SLOT(makeConstYTraceItem()));
	subMenu->addAction("Regression Line", this, SLOT(makeRegLineTraceItem()));
	subMenu->addSeparator();
	subMenu->addAction("Event Label", this, SLOT(makeEventItem()));
	subMenu->addSeparator();
	subMenu->addAction("Panel", this, SLOT(makePanelItem()));
	subMenu->addAction("Time Axis Data Label", this, SLOT(makeTLabItem()));
	subMenu->addSeparator();
	subMenu->addAction("Time Series Frame", this, SLOT(makeTSFrameItem()));
	subMenu->addAction("XY Frame", this, SLOT(makeXYFrameItem()));
	subMenu->addSeparator();
	subMenu->addAction("Page", this, SLOT(makePageItem()));
	
	RButtonMenu->addSeparator();
	RButtonMenu->addAction("Rename", this, SLOT(renameSelectedItem()));
	RButtonMenu->addAction("Cut", this, SLOT(cut()));
	RButtonMenu->addAction("Copy", this, SLOT(copy()));
	RButtonMenu->addAction("Paste", this, SLOT(paste()));
	RButtonMenu->addAction("Duplicate", this, SLOT(duplicate()));
	RButtonMenu->addSeparator();
	RButtonMenu->addAction("Move Up", this, SLOT(moveUp()));
	RButtonMenu->addAction("Move Down", this, SLOT(moveDown()));
	RButtonMenu->addSeparator();
	RButtonMenu->addAction("Plot Selected Pages", this, SLOT(plotSelectedItems()), Qt::CTRL+Qt::Key_P);
	RButtonMenu->addSeparator();
	RButtonMenu->addAction("Use Default Settings", this, SLOT(setDefaultSelectedItems()));
	RButtonMenu->addSeparator();
	RButtonMenu->addAction("Delete", this, SLOT(deleteSelectedItems()));
	RButtonMenu->addSeparator();
	RButtonMenu->addAction("Link Selected Traces", this, SLOT(linkSelected()));
	RButtonMenu->addAction("Unlink Selected Traces", this, SLOT(unlinkSelected()));
	
    RButtonMenu->addSeparator();
    
    // --- SEH ---
    RButtonMenu->addAction("Set X", this, SLOT( fastSelectComponent_x() ), Qt::CTRL+Qt::Key_7);
    RButtonMenu->addAction("Set Y", this, SLOT( fastSelectComponent_y() ), Qt::CTRL+Qt::Key_8);
    RButtonMenu->addAction("Set Z", this, SLOT( fastSelectComponent_z() ), Qt::CTRL+Qt::Key_9);
    RButtonMenu->addAction("Set R", this, SLOT( fastSelectComponent_r() ), Qt::CTRL+Qt::Key_0);
    RButtonMenu->addAction("Set colour C1", this, SLOT( fastSelect_SC1() ), Qt::CTRL+Qt::Key_1);
    RButtonMenu->addAction("Set colour C2", this, SLOT( fastSelect_SC2() ), Qt::CTRL+Qt::Key_2);
    RButtonMenu->addAction("Set colour C3", this, SLOT( fastSelect_SC3() ), Qt::CTRL+Qt::Key_3);
    RButtonMenu->addAction("Set colour C4", this, SLOT( fastSelect_SC4() ), Qt::CTRL+Qt::Key_4);
    RButtonMenu->addAction("Set solid line", this, SLOT( fastSelect_SolidLine() ), Qt::CTRL+Qt::Key_Backslash);
    RButtonMenu->addAction("Set dashed line", this, SLOT( fastSelect_DashedLine() ), Qt::CTRL+Qt::Key_Minus);
    RButtonMenu->addAction("Set dotted line", this, SLOT( fastSelect_DottedLine() ), Qt::CTRL+Qt::Key_Period);

	RButtonMenu->exec(p);
}

// --- shortcut trace options (colors,etc) ---

void  PlotList::fastSelectComponent_x(){
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) traceItem->DataTab->_y_data_fld->setDropdownText_x();
  }
    
  updateOnSelection();
};


void  PlotList::fastSelectComponent_y(){
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) traceItem->DataTab->_y_data_fld->setDropdownText_y();
  }
  updateOnSelection();
};


void  PlotList::fastSelectComponent_z(){
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) traceItem->DataTab->_y_data_fld->setDropdownText_z();
  }
  updateOnSelection();
};


void  PlotList::fastSelectComponent_r(){
  copyList = selectedItems();
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) traceItem->DataTab->_y_data_fld->setDropdownText_r();
  }
  updateOnSelection();
};


void  PlotList::fastSelect_SC1() {    
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->setLineColour(traceItem->C1_colour);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};


void  PlotList::fastSelect_SC2() {    
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->setLineColour(traceItem->C2_colour);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};


void  PlotList::fastSelect_SC3() {    
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->setLineColour(traceItem->C3_colour);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};


void  PlotList::fastSelect_SC4() {    
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->setLineColour(traceItem->C4_colour);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};


void  PlotList::fastSelect_SolidLine(){  
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->_line_style_fld->setCurrentIndex(1);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};

void  PlotList::fastSelect_DashedLine(){
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->_line_style_fld->setCurrentIndex(2);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};


void  PlotList::fastSelect_DottedLine(){  
  copyList = selectedItems();
	
  foreach(QTreeWidgetItem * item, copyList) {
    TraceItem * traceItem = dynamic_cast<TraceItem*>(item);
    if(traceItem) {
        traceItem->TraceTab->_line_style_fld->setCurrentIndex(4);
        traceItem->userLineColour = true;
    }
  }
  updateOnSelection();
};



// --- eo SEH ---

//-------------

void PlotList::mousePressEvent(QMouseEvent* event)
{
	QTreeWidget::mousePressEvent(event);
	
	if(event->button()==Qt::RightButton)
	{
		displayMenu(event->globalPos());
	}
}

//-------------

PageItem* PlotList::makePageItem()
{

	PageItem* res = new PageItem("", this);
//	this->addTopLevelItem(res);
		
	setCurrentItem(res);

	return res;
}

//-------------

PageItem* PlotList::getPageItem(QpuiItem* parent)
{
	if(parent == NULL) parent = (QpuiItem *) currentItem();
	
	if(parent != NULL && parent->page() != NULL) return parent->page();
	
	return new PageItem("", this);
		
}

//-------------

void PlotList::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    if( QuSlotDebug() ) cout << " PlotList::currentChanged " << endl;

	QTreeWidget::currentChanged(current, previous);
	
	updateOnSelection();
}

//-------------

void PlotList::updateOnSelection()
{
    if( QuSlotDebug() ) cout << " PlotList::updateOnSelection " << endl;

	QWidget * oldPage = this->tabWidget->currentWidget();
	if(oldPage)
	{
		QpTab * oldTab = dynamic_cast <QpTab*>(oldPage);
		if(this->I_LastTab == QP_IGNORE_TAB) this->I_LastTab = QP_DATA_TAB;
		else this->I_LastTab = oldTab->TabType;
	}

	// sets tabs appropriate when selection is changed
	QpuiItem *item = dynamic_cast<QpuiItem*>(this->currentItem());

	// show tabs for different item types via virtual method
	if(item) {
		item->showTabs(); 
		this->tabWidget->adjustSize();
	}
	else{
		int Ntabs = this->tabWidget->count();
		for(int i = Ntabs-1; i >= 0; i--) 
		{
			if(this->tabWidget->widget(i))
			{
				this->tabWidget->widget(i)->hide();
				this->tabWidget->removeTab(i);
			}
		}
	}
}

//-------------

void PlotList::setDefaultSelectedItems()
{
    if( QuSlotDebug() ) cout << " PlotList::setDefaultSelectedItems " << endl;

	QList<QTreeWidgetItem *> list = selectedItems();
	foreach(QTreeWidgetItem * item, list) ((QpuiItem *)item)->setDefaultOptions();
}

//-------------

void PlotList::plotSelectedItems()
{
    if( QuSlotDebug() ) cout << " PlotList::plotSelectedItems " << endl;

	_plot_page_list.clear();
	
	QList<QTreeWidgetItem *> list = selectedItems();	
	if(list.isEmpty()) return;
	
	foreach(QTreeWidgetItem* item, list)
	{
		PageItem* pageItem=NULL;
		pageItem=((QpuiItem*)item)->page();
		
		if(pageItem && !_plot_page_list.contains(pageItem))
		{
			_plot_page_list.push_back(pageItem);
		}
	}
	
	if(!_plot_page_list.isEmpty()) plot();
}

//-------------

void PlotList::plot(bool hidden)
{
	PageItem* page_item;
	if(_plot_page_list.isEmpty())
	{
		(void)QMessageBox::warning(this,"Plot",("No Pages Selected..."));
		return;
	}
		
	QApplication::setOverrideCursor( QCursor(Qt::WaitCursor) );
	qApp->processEvents();
	

		for(uint i=0; i<_plot_page_list.size(); i++)
		{
			page_item = _plot_page_list[i];
			if(!page_item) continue;
			
			double width, height;
			double conv;
			width = page_item->PageTab->_width_fld->text().toDouble();
			height =page_item->PageTab->_height_fld->text().toDouble();
			
			int _units = page_item->PageTab->_units_fld->currentIndex();
			conv=page_item->_conversion_factors[_units];
			width=width/conv; //conversion to inches
			height=height/conv; //conversion to inches
			
			conv=page_item->_conversion_factors[0]; // conv factor to pixels
			width=width*conv; //px
			height=height*conv; //px
			
			if(width<=0. || height<=0.)
			{
				width=600.;
				height=800.;
			}
			
			PlotWindow* win = page_item->PageTab->_xwin_num_fld->currentWindow;
            
			QPrinter::Orientation orientation=(page_item->PageTab->_orientation_fld->currentIndex() == QPUI_LANDSCAPE ? QPrinter::Landscape : QPrinter::Portrait);
			QPrinter::PageSize pageSize=QPrinter::A4;
			int resolution=72;
			switch(page_item->PageTab->_page_size_fld->currentIndex())
			{
				case QPUI_EXECUTIVE:
					pageSize=QPrinter::Executive;
					break;
				case QPUI_LEGAL:
					pageSize=QPrinter::Legal;
					break;
				case QPUI_LETTER:
					pageSize=QPrinter::Letter;
					break;
				case QPUI_CUSTOM:
					pageSize=QPrinter::Custom;
					break;
				default: break;
			}
			
			switch(page_item->PageTab->_dpi_fld->currentIndex())
			{
				case QPUI_150_DPI: resolution=150; break;
				case QPUI_300_DPI: resolution=300; break;
				case QPUI_600_DPI: resolution=600; break;
				case QPUI_1200_DPI: resolution=1200; break;
				default: resolution=72; break;
			}
			
			if(win == NULL) // create new window
			{
				win=page_item->PageTab->_xwin_num_fld->newPlotWindow(width, height, resolution, pageSize, orientation, false, hidden);
                win->move(100,20);
			}
			else
			{
				win=page_item->PageTab->_xwin_num_fld->focusWindow(width, height, resolution, pageSize, orientation, false, hidden);
			}
			
			win->disconnect(SIGNAL(clicked(double, double, int, int))); // disconnect possibly pre-existing connections
			
#ifdef Q_OS_MACX
            win->setTitle(QString("(double click on plot to launch interval editor)                    %1   %2 ").arg(page_item->getName()).arg(page_item->PageTab->_xwin_num_fld->getName().c_str()));

			connect(win, SIGNAL(doubleClicked(double, double, int, int)), this, SLOT(displayIntervalWidget(double, double, int, int)));
#else
            win->setTitle(QString("(click on plot to launch interval editor)                        %1   %2 ").arg(page_item->getName()).arg(page_item->PageTab->_xwin_num_fld->getName().c_str()));
			connect(win, SIGNAL(clicked(double, double, int, int)), this, SLOT(displayIntervalWidget(double, double, int, int)));
#endif


			qApp->processEvents();

			
			if(QPUI_FAILURE == page_item->plot(win))
			{
				(void)QMessageBox::warning(this,"Plot", (QString("Problem plotting page %1").arg(page_item->getName())));
			}
			else 
			{
	// fix Mac & Windows problem with spectra not showing until focus change
                if(hidden ) win->hide();
                else{
                    emit raiseWindow();
                    qApp->processEvents();
				
                    win->activateWindow();
                    win->raise();
                }
			}

		}

	
	QApplication::restoreOverrideCursor();
	qApp->processEvents();
		
}

//-------------

void PlotList::duplicate()
{  
	copyList = selectedItems();
	QpuiItem *target=NULL;
	
	foreach(QTreeWidgetItem * item, copyList) {
		if( !(((QpuiItem*)item)->ancestorInList(copyList)) ){
			QpuiItem *newItem = ((QpuiItem*)item)->duplicateItem((QpuiItem*)item->parent());
			target = (QpuiItem *) newItem->parent();
		}
	}
	
	if(target && target->page()){
		setPageLayout(target->page());	
		target->expandChildren();
	}
	
	isCopy = true;
}

//-------------

void PlotList::cut()
{  
	copyList = selectedItems();
	
	foreach(QTreeWidgetItem * item, copyList) {
		PageItem *_page = ((QpuiItem*)item)->page();
		if(!(((QpuiItem*)item)->ancestorInList(copyList))) {
		
			if(item->parent() == NULL) {
				takeTopLevelItem(((QpuiItem*)item)->childNumber());
			}
			else  {
				setCurrentItem(item->parent());
				item->parent()->removeChild(item);
			}
		}
		
		qApp->processEvents();
		setPageLayout(_page);	
	}
	
	updateOnSelection();

	isCopy = false;
}

//-------------

void PlotList::copy()
{  
	copyList = selectedItems();
	isCopy = true;
}

//-------------

void PlotList::paste()
{  
	QApplication::setOverrideCursor( QCursor(Qt::WaitCursor) );
	
	QpuiItem *target = (QpuiItem*) currentItem();

	qApp->processEvents();
	
	if(isCopy){
		foreach(QTreeWidgetItem * item, copyList) 
		{
			if( !(((QpuiItem*)item)->ancestorInList(copyList)) ){
				// top level of selection
				if(item->parent()) {
					if(target && ((QpuiItem*)target)->moveOK((QpuiItem*)item)) {
						QpuiItem* duplicate = ((QpuiItem*)item)->duplicateItem((QpuiItem*)target);
						((QpuiItem*)target)->expandChildren();
					}
				}
				else{
					if(target && ((QpuiItem*)target)->moveOK((QpuiItem*)item)){
						QpuiItem* duplicate = ((QpuiItem*)item)->duplicateItem((QpuiItem*)target);
						((QpuiItem*)duplicate)->expandChildren();
					}
					else {
						// drag to blank area, append page
						QpuiItem* duplicate = ((QpuiItem*)item)->duplicateItem((QpuiItem*)item); // item is page
						((QpuiItem*)duplicate)->expandChildren();
					}
				}
			}
		}
	}
	else{
		// insert cut items
		foreach(QTreeWidgetItem * item, copyList) 
		{
			// insert item itself for cut/paste
			if( !(((QpuiItem*)item)->ancestorInList(copyList)) ){
				// top level of selection
				if(item->parent()) {
					if(target) {
						((QpuiItem*)target)->insertItem((QpuiItem*)item);
						((QpuiItem*)target)->expandChildren();
					}
				}
				else{
					if(target){
						((QpuiItem*)target)->insertItem((QpuiItem*)item);
						((QpuiItem*)target)->expandChildren();
					}
					else {
					// paste to blank area, append page
						insertTopLevelItem(topLevelItemCount(), item);
					}
				}
			}
		}
		copyList.clear(); // multiple pastes of cut item not safe
	}
	QApplication::restoreOverrideCursor();

	if(target) {
		if(target->page()) setPageLayout(target->page());	
		else setPageLayout((PageItem*)target); // is page
	}
	

}

// Drag and drop tools
//-------------


QStringList PlotList::mimeTypes() const
{
	QStringList types;
	types << "application/plotitems";
	types << "application/wlitems";
	return types;
}


//-------------

QpuiItem * PlotList::getItemFromPath(QString &path)
{
	QStringList pathList = path.split("::");
	QpuiItem * found = NULL;
	for(int i=0; i<topLevelItemCount(); i++){
		
		QpuiItem * _page_i = (QpuiItem*) topLevelItem(i);

		if(_page_i->getName() == pathList[0]){
			found = _page_i;
			break;
		}
	}
	if(found == NULL) return NULL;
	
	for(int k=1; k<pathList.size(); k++){

		bool missing = true;
		for(int i=0; i<found->childCount(); i++){
			if(found->child(i)->text(0) == pathList[k]){
				found = (QpuiItem*) found->child(i);
				missing = false;
				break;
			}
		}
		if(missing) return NULL;
	}
	return found;

}

//-------------

QMimeData* PlotList::mimeData(const QList<QTreeWidgetItem *> items ) const
{
	QMimeData *mimeData = new QMimeData();
	
	QStringList idList;

	foreach (QTreeWidgetItem *item, items) {
		idList << ((QpuiItem*)item)->getPath();
	}
	
	QString data=idList.join("//");

	mimeData->setData("application/plotitems", data.toLatin1().data());
	mimeData->setText( ((QpuiItem*)items.first())->getPath());
	return mimeData;
}

//-------------
void PlotList::dropEvent(QDropEvent *event){

	QpuiItem* target = (QpuiItem*) itemAt(event->pos());

	if(QuSlotDebug()) {
		cout << "PlotList::dropEvent on ";
		if(target != NULL) cout << ((QpuiItem*)target)->getName().toLatin1().data();
		else cout << " - no item ";
		cout << endl;
	}

	const QMimeData *data = event->mimeData();
	
	Qt::DropAction action = event->dropAction();
	if (action == Qt::IgnoreAction)
		return;

	if (!data->hasFormat("application/plotitems") && !data->hasFormat("application/wlitems"))
		return;
			

	if(data->hasFormat("application/plotitems"))
	{
		// get dragged item
		QStringList itemStrList=QString(data->data("application/plotitems")).split("//");
		QList <QTreeWidgetItem*> itemList;
		foreach(QString itemStr, itemStrList){
			QTreeWidgetItem *item = getItemFromPath(itemStr);
			if(item && item != target) itemList.push_back(item);
		}
						
		if(action==Qt::CopyAction || action==Qt::MoveAction ) 
		{
			this->clearSelection();
			foreach(QTreeWidgetItem *item, itemList)
			{
				// only move top of each tree dragged
				if( !(((QpuiItem*)item)->ancestorInList(itemList)) ){
					// top level of selection
					if(item->parent()) {
						if(target && ((QpuiItem*)target)->moveOK((QpuiItem*)item)) {
							PanelItem *oldPanel = ((QpuiItem*)item)->panel();
							item->parent()->removeChild(item);
							if(oldPanel) oldPanel->LegendTab->updateNumTraces();

							((QpuiItem*)target)->insertItem((QpuiItem*)item);
						}
					}
					else{
						if(target && ((QpuiItem*)target)->moveOK((QpuiItem*)item)){
							takeTopLevelItem( ((QpuiItem*)item)->childNumber());
							((QpuiItem*)target)->insertItem((QpuiItem*)item);
						}
						else {
							// drag to blank area, append page
							takeTopLevelItem( ((QpuiItem*)item)->childNumber());
							addTopLevelItem(item);
							((QpuiItem*)item)->expandChildren();
						}
					}
				}
			}
		}
	}
	else if(data->hasFormat("application/wlitems"))
	{
		// Drag from WL creates new plot item
		
		if(target == NULL) {
			int indx = topLevelItemCount();
			if(indx > 0) target = (QpuiItem*)topLevelItem(indx -1);
		}

		QApplication::setOverrideCursor( QCursor(Qt::WaitCursor) );

		QStringList itemList=QString(data->data("application/wlitems")).split("//");
				
		if(itemList.size()==1 && dynamic_cast<PlotItem*>(target)!=NULL)
		{
			((PlotItem*)target)->replaceData(itemList[0]);
			((PlotItem*)target)->DataTab->propagateLink();
		}
		else if(itemList.size()==1 && dynamic_cast<TLabItem*>(target)!=NULL)
		{
			((TLabItem*)target)->replaceXData(itemList[0]);
		}
		else
		{				
			foreach(QString itemString, itemList)
			{
				makePlotItem((QpuiItem*)target, itemString);
			}
		}

		QApplication::restoreOverrideCursor();
		
	}

	qApp->processEvents();	
	this->clearSelection();
	if(target) {
		target->setSelected(true);
 		((QpuiItem*)target)->expandChildren();
		if(((QpuiItem*)target)->page()) setPageLayout(((QpuiItem*)target)->page());	 
	}

	return;
}

/*
bool PlotList::dropMimeData(QTreeWidgetItem *target, int index, const QMimeData *data, Qt::DropAction action)
{	
	if(QuSlotDebug()) {
		cout << "PlotList::dropMimeData on ";
		if(target != NULL) cout << ((QpuiItem*)target)->getName().toLatin1().data();
		else cout << " - no item ";
		cout << endl;
	}
	if (action == Qt::IgnoreAction)
		return true;

	if (!data->hasFormat("application/plotitems") && !data->hasFormat("application/wlitems"))
		return false;
			

	if(data->hasFormat("application/plotitems"))
	{
		// get dragged item
		QStringList itemStrList=QString(data->data("application/plotitems")).split("//");
		QList <QTreeWidgetItem*> itemList;
		foreach(QString itemStr, itemStrList){
			QTreeWidgetItem *item = getItemFromPath(itemStr);
			if(item) itemList.push_back(item);
		}
						
		if(action==Qt::CopyAction || action==Qt::MoveAction ) 
		{
			this->clearSelection();
			foreach(QTreeWidgetItem *item, itemList)
			{
				// only move top of each tree dragged
				if( !(((QpuiItem*)item)->ancestorInList(itemList)) ){
					// top level of selection
					if(item->parent()) {
						if(target && ((QpuiItem*)target)->moveOK((QpuiItem*)item)) {
							item->parent()->removeChild(item);
							((QpuiItem*)target)->insertItem((QpuiItem*)item);
						}
					}
					else{
						if(target && ((QpuiItem*)target)->moveOK((QpuiItem*)item)){
							takeTopLevelItem( ((QpuiItem*)item)->childNumber());
							((QpuiItem*)target)->insertItem((QpuiItem*)item);
						}
						else {
							// drag to blank area, append page
							takeTopLevelItem( ((QpuiItem*)item)->childNumber());
							addTopLevelItem(item);
							((QpuiItem*)item)->expandChildren();
						}
					}
				}
			}
		}
	}
	else if(data->hasFormat("application/wlitems"))
	{
		// Drag from WL creates new plot item
		
		if(target == NULL) {
			int indx = topLevelItemCount();
			if(indx > 0) target = (QpuiItem*)topLevelItem(indx -1);
		}
		if(target == NULL) return false;

		QApplication::setOverrideCursor( QCursor(Qt::WaitCursor) );

		QStringList itemList=QString(data->data("application/wlitems")).split("//");
				
		if(itemList.size()==1 && dynamic_cast<PlotItem*>(target)!=NULL)
		{
			((PlotItem*)target)->replaceData(itemList[0]);
			((PlotItem*)target)->DataTab->propagateLink();
		}
		else if(itemList.size()==1 && dynamic_cast<TLabItem*>(target)!=NULL)
		{
			((TLabItem*)target)->replaceXData(itemList[0]);
		}
		else
		{				
			foreach(QString itemString, itemList)
			{
				makePlotItem((QpuiItem*)target, itemString);
			}
		}

		QApplication::restoreOverrideCursor();
		
	}

	qApp->processEvents();	
	this->clearSelection();
	if(target) {
		target->setSelected(true);
 		((QpuiItem*)target)->expandChildren();
		if(((QpuiItem*)target)->page()) setPageLayout(((QpuiItem*)target)->page());	 
	}

	
	return true;
}
*/
//-------------

void PlotList::makePlotItem(QpuiItem * parent, const QString& obj_name)
{
	// create item appropriate for drag-dropped object

	//	Make plot item creating Frame and Panel if needed
	if ( QuSlotDebug() )  cout << "PlotList::makePlotItem - " << obj_name.toLatin1().data() << endl;

	// fetch object
	DvObject_var obj = getWLObject(obj_name.toLatin1().data());
	if(obj.is_nil())  return;
		
	QpFrameType frameType = QP_TS; // default
	if( !obj->hasTimeTags()) frameType = QP_XY;

	PageItem *_page=NULL;
	FrameItem *_frame=NULL;
	PanelItem *_panel=NULL;

	if(parent == NULL) {
		_page = new PageItem("", this);
		_frame = new FrameItem("", _page, frameType);
	}
	else if(dynamic_cast<PageItem*>(parent) != NULL){
		_page = (PageItem*) parent;
		_frame = new FrameItem("", _page, frameType);
	}
	else if(dynamic_cast<FrameItem*>(parent) != NULL){
		_frame = (FrameItem*) parent;
		_page = _frame->page();
	}
	else if(dynamic_cast<PanelItem*>(parent) != NULL){
		_panel = (PanelItem*) parent;
		_frame = _panel->frame();
		_page = _frame->page();
	}
	else{
		_panel = parent->panel();
		if(_panel == NULL) return;
		_frame = _panel->frame();
		_page = _frame->page();
	}

	// default plot type is trace
	QpItemType plot_type = QP_TRACE;
	// check if sequence
	if(obj->seqSize() == 1 && obj->is_event())
	{
        plot_type = QP_CONST_XT;
        frameType = QP_TS;
    }
    else if(obj->seqSize() == 1 && obj->arraySize() == 1 && (obj->is_dbl() || obj->is_int()) ) {
        plot_type = QP_CONST_Y;
    }
	else
	{
		if( !obj->is_dbl() && !obj->is_int())
        {
			(void)QMessageBox::warning(NULL,"","Invalid object type");
			return;
        }
		else if(obj->arraySize() == 1)
		{
			// if timetags, default plot type is ts trace
			plot_type = QP_TRACE;
	
		}
		else if(obj->isThreeVector() )
		{
			QString vectorPlot=QSAS_profiles->current()->Vector3D;
			
			if(_panel)
			{
				// use existing panel with component
				plot_type = QP_TRACE;
			}
			else if(vectorPlot=="RXYZ")
			{
				PlotItem* plotItem=makeVector_RXYZ_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="R_XYZ")
			{
				PlotItem* plotItem=makeVector_R_XYZ_Item(_frame, frameType);
				if(plotItem)
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="XYZ")
			{
				PlotItem* plotItem=makeVector_XYZ_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="R_TP")
			{
				PlotItem* plotItem=makeVector_R_TP_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="R_LP")
			{
				PlotItem* plotItem=makeVector_R_LP_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="R_X_Y_Z")
			{
				PlotItem* plotItem=makeVector_R_X_Y_Z_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="X_Y_Z")
			{
				PlotItem* plotItem=makeVector_X_Y_Z_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="R_T_P")
			{
				PlotItem* plotItem=makeVector_R_T_P_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else if(vectorPlot=="R_L_P")
			{
				PlotItem* plotItem=makeVector_R_L_P_Item(_frame, frameType);
				if(plotItem) 
				{
					plotItem->replaceData(obj_name);
					plotItem->DataTab->propagateLink();
				}
				return;
			}
			else //"R" if everything goes right
				plot_type = QP_TRACE;
				// continue and create scalar trace
		}
		else 
        {
				plot_type = QP_SPECTROGRAM;
		}
        
	}
	
	if(_panel == NULL) _panel = new PanelItem("", _frame);

	// create object of right type
	PlotItem *newPlot = makePlot(_panel, plot_type, frameType, obj_name);
	
	return;
}

//-------------

void PlotList::makeMultiTraceItem(FrameItem* parent, QVector <int> &nTraces, QVector <TraceItem *> &stack, QpFrameType frameType)
{
	stack.clear();
	// Each entry in nTraces is number of traces in a panel, size of nTraces is number of panels
	
	// make page/frame/panels as needed
    if(parent == NULL )
    {
		PageItem *_page = new PageItem("", this);
		parent = new FrameItem("", _page, frameType);
    }
    
	PanelItem* panelItem=NULL;
	
	for(int i=0; i<nTraces.size(); ++i)
	{
		panelItem = new PanelItem("", parent);
		if(panelItem)
		{
			for(int j=0; j<nTraces[i]; ++j)
			{
				TraceItem* traceItem = makeTraceItem(panelItem);
				if(traceItem)
				{
					stack.push_back(traceItem);
				}
			}
		}
	}
	
	if(parent->page()) setPageLayout(parent->page());	 

}

//-------------

TraceItem* PlotList::makeVector_RXYZ_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector<TraceItem *> stack;	
	QVector <int> traces;
	traces.push_back(4);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 4)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[0]->TraceTab->setLineColour(stack[0]->R_colour);
		stack[0]->userLineColour = true;
		stack[0]->DataTab->_show_legend_fld->setChecked(true);
		stack[0]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[1]->DataTab->_y_data_fld->setText(X_STR_CMP);
		stack[1]->TraceTab->setLineColour(stack[1]->X_colour);
		stack[1]->userLineColour = true;
		stack[1]->DataTab->_show_legend_fld->setChecked(true);
		stack[2]->DataTab->_y_data_fld->setText(Y_STR_CMP);
		stack[2]->TraceTab->setLineColour(stack[2]->Y_colour);
		stack[2]->userLineColour = true;
		stack[2]->DataTab->_show_legend_fld->setChecked(true);
		stack[3]->DataTab->_y_data_fld->setText(Z_STR_CMP);
		stack[3]->TraceTab->setLineColour(stack[3]->Z_colour);
		stack[3]->userLineColour = true;
		stack[3]->DataTab->_show_legend_fld->setChecked(true);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];

}

TraceItem* PlotList::makeVector_R_XYZ_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector <TraceItem *> stack;
	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(3);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 4)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[0]->TraceTab->setLineColour(stack[0]->R_colour);
		stack[0]->userLineColour = true;
		stack[0]->DataTab->_show_legend_fld->setChecked(true);
		stack[0]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[1]->DataTab->_y_data_fld->setText(X_STR_CMP);
		stack[1]->TraceTab->setLineColour(stack[1]->X_colour);
		stack[1]->userLineColour = true;
		stack[1]->DataTab->_show_legend_fld->setChecked(true);
		stack[1]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[2]->DataTab->_y_data_fld->setText(Y_STR_CMP);
		stack[2]->TraceTab->setLineColour(stack[2]->Y_colour);
		stack[2]->userLineColour = true;
		stack[2]->DataTab->_show_legend_fld->setChecked(true);
		
		stack[3]->DataTab->_y_data_fld->setText(Z_STR_CMP);
		stack[3]->TraceTab->setLineColour(stack[3]->Z_colour);
		stack[3]->userLineColour = true;
		stack[3]->DataTab->_show_legend_fld->setChecked(true);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];

}

TraceItem* PlotList::makeVector_XYZ_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels

	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(3);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 3)
	{
		stack[0]->DataTab->_y_data_fld->setText(X_STR_CMP);
		stack[0]->TraceTab->setLineColour(stack[0]->X_colour);
		stack[0]->userLineColour = true;
		stack[0]->DataTab->_show_legend_fld->setChecked(true);
		stack[0]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[1]->DataTab->_y_data_fld->setText(Y_STR_CMP);
		stack[1]->TraceTab->setLineColour(stack[1]->Y_colour);
		stack[1]->userLineColour = true;
		stack[1]->DataTab->_show_legend_fld->setChecked(true);
		
		stack[2]->DataTab->_y_data_fld->setText(Z_STR_CMP);
		stack[2]->TraceTab->setLineColour(stack[2]->Z_colour);
		stack[2]->userLineColour = true;
		stack[2]->DataTab->_show_legend_fld->setChecked(true);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];

}

TraceItem* PlotList::makeVector_R_LP_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels

	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(2);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 3)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[0]->TraceTab->setLineColour(stack[0]->R_colour);
		stack[0]->userLineColour = true;
		stack[0]->DataTab->_show_legend_fld->setChecked(true);
		stack[0]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[1]->DataTab->_y_data_fld->setText(Ld_STR_CMP);
		stack[1]->TraceTab->setLineColour(stack[1]->L_colour);
		stack[1]->userLineColour = true;
		stack[1]->DataTab->_show_legend_fld->setChecked(true);
		stack[1]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[2]->DataTab->_y_data_fld->setText(Pd_STR_CMP);
		stack[2]->TraceTab->setLineColour(stack[2]->P_colour);
		stack[2]->userLineColour = true;
		stack[2]->DataTab->_show_legend_fld->setChecked(true);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];

}

TraceItem* PlotList::makeVector_R_TP_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(2);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 3)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[0]->TraceTab->setLineColour(stack[0]->R_colour);
		stack[0]->userLineColour = true;
		stack[0]->DataTab->_show_legend_fld->setChecked(true);
		stack[0]->panel()->LegendTab->_show_legend_fld->setChecked(true);

		stack[1]->DataTab->_y_data_fld->setText(Td_STR_CMP);
		stack[1]->TraceTab->setLineColour(stack[1]->T_colour);
		stack[1]->userLineColour = true;
		stack[1]->DataTab->_show_legend_fld->setChecked(true);
		stack[1]->panel()->LegendTab->_show_legend_fld->setChecked(true);
		
		stack[2]->DataTab->_y_data_fld->setText(Pd_STR_CMP);
		stack[2]->TraceTab->setLineColour(stack[2]->P_colour);
		stack[2]->userLineColour = true;
		stack[2]->DataTab->_show_legend_fld->setChecked(true);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];

}

TraceItem* PlotList::makeVector_R_X_Y_Z_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 4)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[1]->DataTab->_y_data_fld->setText(X_STR_CMP);
		stack[2]->DataTab->_y_data_fld->setText(Y_STR_CMP);
		stack[3]->DataTab->_y_data_fld->setText(Z_STR_CMP);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::makeVector_X_Y_Z_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 3)
	{
		stack[0]->DataTab->_y_data_fld->setText(X_STR_CMP);
		stack[1]->DataTab->_y_data_fld->setText(Y_STR_CMP);
		stack[2]->DataTab->_y_data_fld->setText(Z_STR_CMP);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::makeVector_R_T_P_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 3)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[1]->DataTab->_y_data_fld->setText(Td_STR_CMP);
		stack[2]->DataTab->_y_data_fld->setText(Pd_STR_CMP);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::makeVector_R_L_P_Item(FrameItem* parent, QpFrameType frameType)
{
	// create panels
	QVector <TraceItem *> stack;	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, frameType);
	
	// set component text
	if(stack.size() == 3)
	{
		stack[0]->DataTab->_y_data_fld->setText(R_STR_CMP);
		stack[1]->DataTab->_y_data_fld->setText(Ld_STR_CMP);
		stack[2]->DataTab->_y_data_fld->setText(Pd_STR_CMP);
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::makeC1_2_3_4_Item(FrameItem* parent)
{
	// create panels
	QVector <TraceItem *> stack;
	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, QP_TS);
	
	// set component text
	if(stack.size() == 4)
	{
		stack[0]->DataTab->_y_data_fld->setText("?C2=C1? ?C3=C1? ?C4=C1? ?dr2=dr1? ?dr3=dr1? ?dr4=dr1?");
		stack[0]->TraceTab->setLineColour(stack[0]->C1_colour);
		stack[0]->userLineColour = true;
		stack[1]->DataTab->_y_data_fld->setText("?C1=C2? ?C3=C2? ?C4=C2? ?dr1=dr2? ?dr3=dr2? ?dr4=dr2?");
		stack[1]->TraceTab->setLineColour(stack[1]->C2_colour);
		stack[1]->userLineColour = true;
		stack[2]->DataTab->_y_data_fld->setText("?C1=C3? ?C2=C3? ?C4=C3? ?dr1=dr3? ?dr2=dr3? ?dr4=dr3?");
		stack[2]->TraceTab->setLineColour(stack[2]->C3_colour);
		stack[2]->userLineColour = true;
		stack[3]->DataTab->_y_data_fld->setText("?C1=C4? ?C2=C4? ?C3=C4? ?dr1=dr4? ?dr2=dr4? ?dr3=dr4?");
		stack[3]->TraceTab->setLineColour(stack[3]->C4_colour);
		stack[3]->userLineColour = true;
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::makeC1234_Item(FrameItem* parent)
{
	// create panels
	QVector <TraceItem *> stack;
	QVector <int> traces;
	traces.push_back(4);
	makeMultiTraceItem(parent, traces, stack, QP_TS);
	
	// set component text
	if(stack.size() == 4)
	{
		stack[0]->DataTab->_y_data_fld->setText("?C2=C1? ?C3=C1? ?C4=C1? ?dr2=dr1? ?dr3=dr1? ?dr4=dr1?");
		stack[0]->TraceTab->setLineColour(stack[0]->C1_colour);
		stack[0]->userLineColour = true;
		stack[1]->DataTab->_y_data_fld->setText("?C1=C2? ?C3=C2? ?C4=C2? ?dr1=dr2? ?dr3=dr2? ?dr4=dr2?");
		stack[1]->TraceTab->setLineColour(stack[1]->C2_colour);
		stack[1]->userLineColour = true;
		stack[2]->DataTab->_y_data_fld->setText("?C1=C3? ?C2=C3? ?C4=C3? ?dr1=dr3? ?dr2=dr3? ?dr4=dr3?");
		stack[2]->TraceTab->setLineColour(stack[2]->C3_colour);
		stack[2]->userLineColour = true;
		stack[3]->DataTab->_y_data_fld->setText("?C1=C4? ?C2=C4? ?C3=C4? ?dr1=dr4? ?dr2=dr4? ?dr3=dr4?");
		stack[3]->TraceTab->setLineColour(stack[3]->C4_colour);
		stack[3]->userLineColour = true;
	}
	
	// link data slots together
 	linkTraceItems(stack, true);

    if (parent!=NULL) parent->expandChildren();
	return stack[0];

}

TraceItem* PlotList::make2Panel_Item(FrameItem* parent)
{
	// create panels
	QVector <TraceItem *> stack;
	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, QP_TS);
	
    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::make3Panel_Item(FrameItem* parent)
{
	// create panels
	QVector <TraceItem *> stack;
	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, QP_TS);
 
    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

TraceItem* PlotList::make4Panel_Item(FrameItem* parent)
{
	// create panels
	QVector <TraceItem *> stack;
	QVector <int> traces;
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	traces.push_back(1);
	makeMultiTraceItem(parent, traces, stack, QP_TS);
	
    if (parent!=NULL) parent->expandChildren();
	return stack[0];
}

//-------------

PlotItem* PlotList::makePlot(PanelItem * parent, QpItemType plotType, QpFrameType frameType, const QString& WL)
{
	// creates a plot item of the correct type. 
	if ( QuSlotDebug() ) 
	{
		cout << "PlotList::makePlot - '" << WL.toLatin1().data();
		if(parent) cout << "' in target '" <<  parent->getName().toLatin1().data() << "'" << endl;
		else cout << endl;
	}
	
	if(parent == NULL) return NULL;
        
	PlotItem* newItem=NULL;

	switch(plotType)
	{
		case QP_TRACE:
			newItem = makeTraceItem(parent, WL);
			break;
		case QP_CONST_Y:
		case QP_CONST_XT:
		case QP_REG_LINE:
			newItem = makeConstTrace(parent, WL, plotType, frameType);
			break;
		case QP_SPECTROGRAM:
			newItem = makeSpectrumItem(parent, WL);
			break;
		case QP_EVENT:
			newItem = makeEventItem(parent, WL);
			break;
		default:
			std::cout << "unknown plot type " << plotType << std::endl;
			break;
	}

	qApp->processEvents();
	
	if(newItem != NULL) this->setCurrentItem(newItem);

	return newItem;
}

//-------------

PanelItem* PlotList::makePanelItem(QpuiItem* parent, const QString& WL){

	if(parent == NULL) parent = (QpuiItem*) currentItem();
	
	PageItem *_page = NULL;
	FrameItem *_frame = NULL;
	PanelItem *_panel = NULL;
	if(parent == NULL){
		_page = new PageItem("", this);
		_frame = new FrameItem("", _page);
		_panel = new PanelItem(WL, _frame);
	}
	else if(dynamic_cast<PageItem*>(parent) != NULL){
		_page = (PageItem*) parent;
		_frame = new FrameItem("", _page);
		_panel = new PanelItem(WL, _frame);
	}
	else if(dynamic_cast<FrameItem*>(parent) != NULL){
		_frame = (FrameItem*) parent;
		_panel = new PanelItem(WL, _frame);
	}
	else	_panel = new PanelItem(WL, parent->frame());
	
	clearSelection();
	this->setCurrentItem(_panel);

	if(_panel->page()) setPageLayout(_panel->page());	 

	return _panel;
}

//-------------

PanelItem* PlotList::getPanelItem(QpuiItem* parent, const QString& WL){

	if(parent == NULL) parent = (QpuiItem *) currentItem();
	
	PageItem *_page = NULL;
	FrameItem *_frame = NULL;
	PanelItem *_panel = NULL;
	if(parent == NULL){
		_page = new PageItem("", this);
		_frame = new FrameItem("", _page);
		_panel = new PanelItem(WL, _frame);
	}
	else if(dynamic_cast<PageItem*>(parent) != NULL){
		_page = (PageItem*) parent;
		_frame = new FrameItem("", _page);
		_panel = new PanelItem(WL, _frame);
	}
	else if(dynamic_cast<FrameItem*>(parent) != NULL){
		_frame = (FrameItem*) parent;
		_panel = new PanelItem(WL, _frame);
	}
	else	_panel = parent->panel();

	if(_panel->page()) setPageLayout(_panel->page());	 
	
	return _panel;
}

//-------------

void PlotList::makeConstYTraceItem(){

	PanelItem *_panel = getPanelItem();
	if(_panel == NULL) return;
	
	makeConstTrace(_panel, "", QP_CONST_Y, _panel->frameType() );
}

//-------------

void PlotList::makeConstXTraceItem(){

	PanelItem *_panel = getPanelItem();
	if(_panel == NULL) return;
	
	makeConstTrace(_panel, "", QP_CONST_XT, _panel->frameType());
}

//-------------

void PlotList::makeRegLineTraceItem(){

	PanelItem *_panel = getPanelItem();
	if(_panel == NULL) return;
	
	makeConstTrace(_panel, "", QP_REG_LINE, _panel->frameType());
}

//-------------

TraceItem* PlotList::makeConstTrace(PanelItem* parent, const QString& WL, QpItemType plotType, QpFrameType frameType)
{
	// creates new trace item in panel
	if(parent == NULL) return NULL;
	
	TraceItem* traceItem = new TraceItem(WL, parent, WL, plotType);
	traceItem->setDataYObj(WL);
	
	if(traceItem==NULL)
	{
		return NULL;
	}
	
	QString plot_name;
	if(WL.isEmpty())
	{
		traceItem->setNextName();
	}
	else {

		if(plotType==QP_CONST_XT && frameType==QP_TS){
			traceItem->DataTab->_y_data_fld->setTimeDropdownDefault();
		}
		
	}
	
	clearSelection();
	if (parent!=NULL) parent->expandChildren();
	
	// make newest item selected item
	this->setCurrentItem(traceItem);

	return traceItem;

}

//-------------

TraceItem* PlotList::makeTraceItem( QpuiItem* parent, const QString& WL)
{
	// 	creates new trace item in panel
	
	PanelItem *_panel = getPanelItem(parent);
	if(_panel == NULL) return NULL;
	
	TraceItem* traceItem = new TraceItem(WL, _panel, WL, QP_TRACE);	
	
	if(WL.isEmpty())
	{
		traceItem->setNextName();
	}

	((PanelItem*)traceItem->parent())->LegendTab->updateNumTraces();

	traceItem->setDataYObj(WL);
		
	clearSelection();
	_panel->expandChildren();
	
	// make newest item selected item
	this->setCurrentItem(traceItem);
	
	return traceItem;
}

//-------------

TLabItem* PlotList::makeTLabItem(QpuiItem* parent, const QString& WL)
{
	TLabItem* res=NULL;
	
	// get panel, if not empty make new one
	PanelItem *_panel = getPanelItem(parent);
		
	if(_panel == NULL) return NULL;
	
	if(_panel->frame()->frameType() == QP_XY) return res;
		
	res = new TLabItem("", _panel, "", QP_T_LAB);
	
	clearSelection();
	_panel->parent()->expandChildren();
	
	// make newest item selected item
	if(res) this->setCurrentItem(res);

	if(res->page()) setPageLayout(res->page());
		
	return res;
}

//-------------

SpectrumItem* PlotList::makeSpectrumItem(QpuiItem* parent, const QString& WL)
{
	if(parent == NULL) parent = (QpuiItem *) currentItem();
	PanelItem *_panel = getPanelItem(parent);
	if(_panel == NULL) return NULL;
	
	QString plot_name;
	if(WL.isEmpty())
	{
		int plot_cnt = parent->childCount();
		plot_name = "Plot ";
        
        DvString strVal = ++plot_cnt;
		plot_name += strVal.c_str();
		plot_name += ": Spect";
	}
	else
	{
		plot_name = WL;
	}
	
	SpectrumItem* spectrumItem = new SpectrumItem(plot_name, _panel, WL);
	spectrumItem->setDataZObj(WL);

	clearSelection();
	_panel->expandChildren();
	
	// make newest item selected item
	this->setCurrentItem(spectrumItem);

	return spectrumItem;
}

//-------------

EventItem* PlotList::makeEventItem(QpuiItem* parent, const QString& WL)
{
	if(parent == NULL) parent = (QpuiItem*) currentItem();
	PanelItem *_panel = getPanelItem(parent);
	if(_panel == NULL) return NULL;
	
	int plot_cnt = _panel->childCount();
    DvString plot_name("Plot ");
    plot_name += ++plot_cnt;
    plot_name += ": Event";
	EventItem* eventItem = new EventItem(plot_name.c_str(), _panel, "");

	clearSelection();	
	this->setCurrentItem(eventItem);
	
	return eventItem;
}




//-------------

FrameItem* PlotList::makeXYFrameItem(QpuiItem* parent)
{
	PageItem *_page = getPageItem(parent);
	
	if(_page == NULL) return NULL;

	int frame_cnt = _page->childCount();
	QString frame_name=QString("Frame %1").arg(frame_cnt+1);
	FrameItem* frameItem = new FrameItem(frame_name, _page, QP_XY);
	
	clearSelection();	
	_page->expandChildren();
	
	// make newest item selected item
	this->setCurrentItem(frameItem);

	setPageLayout(_page);	

	return frameItem;
}

//-------------

FrameItem* PlotList::makeTSFrameItem(QpuiItem* parent)
{
	PageItem *_page = getPageItem(parent);
	
	if(_page == NULL) return NULL;

	int frame_cnt = _page->childCount();
	QString frame_name=QString("Frame %1").arg(frame_cnt+1);
	FrameItem* frameItem = new FrameItem(frame_name, _page, QP_TS);

	clearSelection();	
	_page->expandChildren();

	// make newest item selected item
	this->setCurrentItem(frameItem);

	setPageLayout(_page);
	
	return frameItem;
}

//-------------

void PlotList::moveUp()
{
	// find selected item
	QpuiItem * item = (QpuiItem*) this->currentItem(); 
	if(item == NULL) return;
	
	PanelItem * oldPanel = item->panel();
	
	QTreeWidgetItem * itemParent = item->parent(); 
	
	QpuiItem * above = sameLevelAbove(item);
	bool sameFolder = false;
	if(above) sameFolder = (itemParent == above->parent());
	
	// special case of empty folder above
		
	if(itemParent && !sameFolder){
		QpuiItem * folderAbove = sameLevelAbove((QpuiItem*)itemParent);	
		if(folderAbove && folderAbove->childCount() == 0 ) {
			itemParent->removeChild(item);
			folderAbove->insertChild(0, item);
			setCurrentItem(item);
			item->expandChildren();
			return;
		}
	}
	
	if(above == NULL) return;
	
	// remove from list
	if(itemParent) {		
		// not page
		itemParent->removeChild(item);
		if(sameFolder) above->insertAbove(item);
		else above->insertBelow(item);
	}
	else {
		// page item
		item = (QpuiItem*) this->takeTopLevelItem(item->childNumber());
		above->insertAbove(item);
	}

	item->setName(item->getName()); // ensures name is unique at this level
	
	clearSelection();
	this->setCurrentItem(item);
	item->expandChildren();

	if(item->page()) setPageLayout(item->page());
	if(oldPanel) oldPanel->LegendTab->updateNumTraces();
	if(item->panel()) item->panel()->LegendTab->updateNumTraces();
	
}

//-------------

void PlotList::moveDown()
{
	// find selected item
	QpuiItem * item = (QpuiItem*) this->currentItem(); 
	if(item == NULL) return;
	
	PanelItem * oldPanel = item->panel();

	QTreeWidgetItem * itemParent = item->parent(); 
	
	QpuiItem * below = sameLevelBelow(item);
	bool sameFolder = false;
	if(below) sameFolder = (itemParent == below->parent());
	
	// special case of empty folder below
		
	if(itemParent && !sameFolder){
		QpuiItem * folderBelow = sameLevelBelow((QpuiItem*)itemParent);	
		if(folderBelow && folderBelow->childCount() == 0 ) {
			itemParent->removeChild(item);
			folderBelow->insertChild(0, item);
			setCurrentItem(item);
			item->expandChildren();
			return;
		}
	}
	
	if(below == NULL) return;
	
	// remove from list
	if(itemParent) {		
		// not page
		itemParent->removeChild(item);
		if(sameFolder) below->insertBelow(item);
		else below->insertAbove(item);
	}
	else {
		// page item
		item = (QpuiItem*) this->takeTopLevelItem(item->childNumber());
		below->insertBelow(item);
	}

	item->setName(item->getName()); // ensures name is unique at this level
	
	clearSelection();
	this->setCurrentItem(item);
	item->expandChildren();
	
	if(item->page()) setPageLayout(item->page());
	if(oldPanel) oldPanel->LegendTab->updateNumTraces();
	if(item->panel()) item->panel()->LegendTab->updateNumTraces();

}

//-------------

QpuiItem* PlotList::sameLevelAbove(QpuiItem *item){
	
	if(item == NULL) return NULL;
	
	QpuiItem *above = (QpuiItem *) itemAbove(item);
		
	while(above){
		if(above->level() == item->level()) return above;
		above = (QpuiItem *) itemAbove(above);
	}
	return above; // NULL
	
}

//-------------

QpuiItem* PlotList::sameLevelBelow(QpuiItem *item){

	if(item == NULL) return NULL;

	QpuiItem *below = (QpuiItem *) itemBelow(item);
		
	while(below){
		if(below->level() == item->level()) return below;
		below = (QpuiItem *) itemBelow(below);
	}
	return below; // NULL

}

//-------------

void PlotList::getLinkFlags(QList<QString>& io_list, QpuiItem* parent)
{
	if(parent==NULL) return;
	
	PlotItem* plotItem=dynamic_cast<PlotItem*>(parent);
	
	if(plotItem!=NULL)
	{
		QString currentText=plotItem->getLinkText();
		if(!currentText.isEmpty() && !io_list.contains(currentText) && currentText.contains("S"))
		{
			io_list.push_back(currentText);
		}
	}
	for(int i=0; i<parent->childCount(); ++i)
	{
		getLinkFlags(io_list, (QpuiItem*) parent->child(i));
	}
}

//-------------

void PlotList::getLinkedItems(QList<PlotItem*>& io_list, QpuiItem* current, const QString& flag)
{
	PlotItem* plotItem=dynamic_cast<PlotItem*>(current);
	
	if(plotItem!=NULL)
	{
		if(plotItem->getLinkText()==flag) io_list.push_back(plotItem);
	}
	else
	{
		for(int i=0; i<current->childCount(); ++i)
		{
			getLinkedItems(io_list, (QpuiItem*) current->child(i), flag);
		}
	}
}

//-------------

void PlotList::linkPlots(QList<PlotItem*>& linkedItems)
{
	LinkNumber++;
	
	QString LinkText=QString("*%1").arg(LinkNumber);
	
	foreach(PlotItem* item, linkedItems)
	{
		item->setLinkText(LinkText);
		item->setLinks(linkedItems);
	}
}

//-------------

void PlotList::linkTraceItems(QVector<TraceItem*>& stack, bool onceOnly)
{
	//  invoked to link traces in multi-panel creation
	QString LinkText;
	
	LinkNumber++;
	LinkText = QString("*%1").arg(LinkNumber);
	if(onceOnly) LinkText.insert(0, "*"); // extra * for searching on link once only
	QList<PlotItem*> linkedPlots;
	for(int i=0; i<stack.size(); i++)
	{
		PlotItem* item=dynamic_cast<PlotItem*>(stack[i]);
		linkedPlots.push_back(item);
		item->setLinkText(LinkText);
	}
	// now tell each trace
	for(int i=0; i<stack.size(); i++)
	{
		PlotItem *plot_item = dynamic_cast<PlotItem*>(stack[i]);
		if(!plot_item) continue;
		plot_item->setLinks(linkedPlots);
	}
}

//-------------

void PlotList::changePlotType(PlotItem *plotItem, QpItemType plotType)
{
	if(QuSlotDebug())
	{
		printf("PlotList::changePlotType %d\n", plotType);
		fflush(stdout);
	}
	if(plotItem == NULL) return;
		
	PanelItem* panelItem = (PanelItem*) plotItem->parent();
	TraceItem * traceItem = dynamic_cast<TraceItem*>(plotItem);
	SpectrumItem * spectrumItem = dynamic_cast<SpectrumItem*>(plotItem);
	
	QString WLcontext = "";
	QString dataName;
	
	if(traceItem)
	{
        dataName = traceItem->DataTab->_y_data_fld->text().toLatin1().data();
		WLcontext = baseObjectText(dataName.toLatin1().data()).c_str();		
		deleteItem(traceItem);
	}
	else if(spectrumItem)
	{
		dataName = QString(spectrumItem->DataTab->_z_data_fld->text().toLatin1().data());
		WLcontext = baseObjectText(dataName.toLatin1().data()).c_str();
		deleteItem(spectrumItem);
	}
	

	switch(plotType)
	{
		default: case QP_TRACE: case QP_CONST_Y: case QP_CONST_XT: case QP_REG_LINE:
		{
			TraceItem* newItem=new TraceItem(dataName, panelItem, WLcontext, plotType);
			newItem->setDataYObj(WLcontext);
			setCurrentItem(newItem);
			break;
		}
		case QP_SPECTROGRAM:
		{
			
			SpectrumItem * newItem= new SpectrumItem(dataName, panelItem, WLcontext);
			newItem->setDataZObj(WLcontext);
			setCurrentItem(newItem);
			
			break;
		}
	}
	I_LastTab = QP_IGNORE_TAB; // tell updateOnSelection to ignore last tab and use DataTab
}

//-------------

void PlotList::deleteItem(QpuiItem* item)
{	
	if(item==NULL ) return;

	qApp->processEvents();
	PageItem* _page = item->page();
	FrameItem* _itemFrame = item->frame();
	
	PageItem *_pageItem = dynamic_cast<PageItem*>(item);
	if (_pageItem) {
		delete _pageItem;
		return;
	}
	FrameItem *_frame = dynamic_cast<FrameItem*>(item);
	if (_frame) {
		delete _frame;
		if(_page) setPageLayout(_page);
		return;
	}
	PanelItem *_panel = dynamic_cast<PanelItem*>(item);
	if (_panel) {
		delete _panel;
		if(_page) setPageLayout(_page);
        if(_itemFrame) _itemFrame->updateAxes();
		return;
	}
	TraceItem *_trace = dynamic_cast<TraceItem*>(item);
	if (_trace) {
		delete _trace;
		if(_page) setPageLayout(_page);
        if(_itemFrame) _itemFrame->updateAxes();
		return;
	}
	SpectrumItem *_spect = dynamic_cast<SpectrumItem*>(item);
	if (_spect) {
		delete _spect;
		if(_page) setPageLayout(_page);
        if(_itemFrame) _itemFrame->updateAxes();
		return;
	}
	EventItem *_event = dynamic_cast<EventItem*>(item);
	if (_event) {
		delete _event;
		if(_page) setPageLayout(_page);
		return;
	}
	TLabItem *_TLab = dynamic_cast<TLabItem*>(item);
	if (_TLab) {
		delete _TLab;
		if(_page) setPageLayout(_page);
		return;
	}
	
	
	return;
}

//-------------

QDomElement PlotList::toXMLElement(QDomDocument& doc) const
{
    QDomElement xml=doc.createElement("Plot_Layout");

    int numPages = topLevelItemCount();

	savedPalette.clear();
    for(int i=0; i<numPages; ++i) ((QpuiItem*)topLevelItem(i))->addCustomColourTableTo(savedPalette);
	
	foreach(ColourTable table, savedPalette)
    {
		xml.appendChild(createTextXMLNode(doc, "ColourTable", table.toString()));
    }
	
    xml.setAttribute("size", QString::number(numPages));
    
    for(int i=0; i<numPages; ++i)
    {
        xml.appendChild(((PageItem*)topLevelItem(i))->toXMLElement(doc));
    }
    return xml;
}

//-------------

void PlotList::fromXMLElement(QDomElement& el, bool _replace)
{
    if(_replace)
    {
        for (int i=0; i<plotWindows->size(); i++) delete (*plotWindows)[i]; 
        plotWindows->clear();

        
        importedPalette.clear();
        clear();
    }
	int itemStart = this->topLevelItemCount();
	
    importedPaletteOffset=importedPalette.size();
        
	QDomElement colourTable=el.firstChildElement("ColourTable");

	while(!colourTable.isNull())
	{
		QString s=colourTable.firstChild().nodeValue();
		ColourTable temp;
		temp.fromString(s);
		importedPalette.push_back(temp);
		colourTable=colourTable.nextSiblingElement("ColourTable");
	}

    int cnt=el.attribute("size", "0").toInt();

    if(cnt!=0)
    {

        QDomElement pageElement=el.firstChildElement("Page_Item");
        while(!pageElement.isNull())
        {
            PageItem* page=new PageItem("", this);
            page->fromXMLElement(pageElement);
            pageElement=pageElement.nextSiblingElement("Page_Item");
        }
    }

    // relink items now everything is restored
    QList<QString> linkFlags;
    
    // Make list of flags
    for(int i=itemStart; i<cnt+itemStart; ++i) getLinkFlags(linkFlags, (PageItem*)topLevelItem(i));

	foreach(QString flag, linkFlags)
	{
		QList<PlotItem*> linkedItems;
        for(int i=itemStart; i<cnt+itemStart; ++i) getLinkedItems(linkedItems, (PageItem*)topLevelItem(i), flag);
        
		linkPlots(linkedItems);
        
	}
}

// ------------   Options -----------


void PlotList::setPageOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;

	if(QuSlotDebug()) cout << "PlotList::setPageOption" << endl;

	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		PageItem* page_item=dynamic_cast<PageItem*>(item);
    
		if(!page_item) continue;
		
		// don't set Page of visible tab - user just did this - avoid infinite loop
		if(page_item->PageTab->isVisible()) continue;
		if(page_item->LayoutTab->isVisible()) continue;
		
        if(counter != thisCounter) continue; // overtaken by events, skip this one
		switch(option)
		{
		
			// Layout Tab
			case AUTOLAYOUT:
				page_item->LayoutTab->_autolayout_fld->setChecked(bChoice);
				page_item->setFramesAuto(bChoice);

				break;
			case NUM_ROWS:
				page_item->LayoutTab->_row_num_fld->setValue(iChoice);
				break;
			case NUM_COLS:
				page_item->LayoutTab->_col_num_fld->setValue(iChoice);
				break;
			case HGAP:
				page_item->LayoutTab->_hgap_fld->setValue(fChoice);
				break;
			case VGAP:
				page_item->LayoutTab->_vgap_fld->setValue(fChoice);
				break;
			case LMARGIN:
				page_item->LayoutTab->_lmargin_fld->setValue(fChoice);
				break;
			case RMARGIN:
				page_item->LayoutTab->_rmargin_fld->setValue(fChoice);
				break;
			case TMARGIN:
				page_item->LayoutTab->_tmargin_fld->setValue(fChoice);
				break;
			case BMARGIN:
				page_item->LayoutTab->_bmargin_fld->setValue(fChoice);
				break;
				
			// Page Tab
			case PAGE_SIZE:
				page_item->PageTab->_page_size_fld->setCurrentIndex(iChoice);
                page_item->updateIsotropicFrames();
				break;
			case PAGE_UNITS:
				page_item->PageTab->_units_fld->setCurrentIndex(iChoice);
				break;
			case PAGE_DPI:
				page_item->PageTab->_dpi_fld->setCurrentIndex(iChoice);
				break;
			case PAGE_WIDTH:
				page_item->PageTab->_width_fld->setText(sChoice);
                page_item->updateIsotropicFrames();
				break;
			case PAGE_HEIGHT:
				page_item->PageTab->_height_fld->setText(sChoice);
                page_item->updateIsotropicFrames();
				break;
			case PAGE_ORIENTATION:
				page_item->PageTab->_orientation_fld->setCurrentIndex(iChoice);
                page_item->updateIsotropicFrames();
				break;
			case IDENT:
				page_item->PageTab->_show_ident_fld->setChecked(bChoice);
				break;
			default:
				break;
				
		}
		setPageLayout(page_item);

	} // end for over local list
}
		
void PlotList::setFrameOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;

	if(QuSlotDebug()) cout << "PlotList::setFrameOption" << endl;

    // apply Panel option to all selected panels (that belonging to visible tab is always selected)
    double page_ratio;

	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		FrameItem* frame_item=dynamic_cast<FrameItem*>(item);
    
		if( !frame_item) continue;
	  
		// don't set panel for visible tab - user just did this - avoid infinite loop
		if(frame_item->PropertiesTab->isVisible()) continue;
		if(frame_item->DisplayTab->isVisible()) continue;
		if(frame_item->TitleTab->isVisible()) continue;
	  
        if(counter != thisCounter) continue; // overtaken by events, skip this one
		switch(option)
		{
			// Display Tab
			case PANEL_LINE_WIDTH:
				frame_item->DisplayTab->_line_width_fld->setValue(fChoice);
				break;
			case PANEL_LINE_COLOUR:
			{
				QPalette line_palette = QPalette(QPUI_normal_palette);
				line_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				line_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				frame_item->DisplayTab->_line_colour_fld->setPalette(line_palette);
				frame_item->_line_colour = cChoice;
				break;
			}
			case TICKS_LENGTH:
				frame_item->DisplayTab->_ticks_length_fld->setValue(fChoice);
				break;
			case TOP_AXIS:
				frame_item->DisplayTab->_show_top_axis_fld->setChecked(bChoice);
				break;
			case BOTTOM_AXIS:
				frame_item->DisplayTab->_show_bottom_axis_fld->setChecked(bChoice);
				break;
			case LEFT_AXIS:
				frame_item->DisplayTab->_show_left_axis_fld->setChecked(bChoice);
				break;
			case RIGHT_AXIS:
				frame_item->DisplayTab->_show_right_axis_fld->setChecked(bChoice);
				break;
			case LR_ALTERNATING_AXIS:
				frame_item->DisplayTab->_show_lr_alternating_axis_fld->setChecked(bChoice);
				break;
			case RL_ALTERNATING_AXIS:
				frame_item->DisplayTab->_show_rl_alternating_axis_fld->setChecked(bChoice);
				break;
			case TOP_TICKS_LABELS:
				frame_item->DisplayTab->_show_top_ticks_labels_fld->setChecked(bChoice);
				break;
			case BOTTOM_TICKS_LABELS:
				frame_item->DisplayTab->_show_bottom_ticks_labels_fld->setChecked(bChoice);
				break;
			case LEFT_TICKS_LABELS:
				frame_item->DisplayTab->_show_left_ticks_labels_fld->setChecked(bChoice);
				break;
			case RIGHT_TICKS_LABELS:
				frame_item->DisplayTab->_show_right_ticks_labels_fld->setChecked(bChoice);
				break;
			case LR_ALTERNATING_TICKS_LABELS:
				frame_item->DisplayTab->_show_lr_alternating_ticks_labels_fld->setChecked(bChoice);
				break;
			case RL_ALTERNATING_TICKS_LABELS:
				frame_item->DisplayTab->_show_rl_alternating_ticks_labels_fld->setChecked(bChoice);
				break;
			case TOP_LABELS:
				frame_item->DisplayTab->_show_top_labels_fld->setChecked(bChoice);
				break;
			case BOTTOM_LABELS:
				frame_item->DisplayTab->_show_bottom_labels_fld->setChecked(bChoice);
				break;
			case LEFT_LABELS:
				frame_item->DisplayTab->_show_left_labels_fld->setChecked(bChoice);
				break;
			case RIGHT_LABELS:
				frame_item->DisplayTab->_show_right_labels_fld->setChecked(bChoice);
				break;
			case LR_ALTERNATING_LABELS:
				frame_item->DisplayTab->_show_lr_alternating_labels_fld->setChecked(bChoice);
				break;
			case RL_ALTERNATING_LABELS:
				frame_item->DisplayTab->_show_rl_alternating_labels_fld->setChecked(bChoice);
				break;
			case Y_IS_ZERO:
				frame_item->DisplayTab->_show_yiszero_fld->setChecked(bChoice);
				break;
			case X_IS_ZERO:
				frame_item->DisplayTab->_show_xiszero_fld->setChecked(bChoice);
				break;
			//  Frame Properties Tab
			case LOFFSET:
				frame_item->PropertiesTab->_loffset_fld->setValue(fChoice);
				break;
			case TOFFSET:
				frame_item->PropertiesTab->_toffset_fld->setValue(fChoice);
				break;
			case WIDTH:
				frame_item->PropertiesTab->_width_fld->setValue(fChoice);
                switch(frame_item->PropertiesTab->_aspect_ratio_fld->currentIndex())
                {
                    case QPUI_FIXED:
                        frame_item->PropertiesTab->_height_fld->setValue(fChoice*frame_item->PropertiesTab->_aspect_ratio);
                        break;

                    case QPUI_SQUARE_ASPECT:
                        page_ratio=frame_item->page()->aspectRatio();
                        frame_item->PropertiesTab->_height_fld->setValue(fChoice*page_ratio);
                        break;

                    case QPUI_ISOTROPIC:
                        frame_item->PropertiesTab->_height_fld->setValue(fChoice*frame_item->PropertiesTab->_aspect_ratio);
                        break;

                    default:
                        frame_item->PropertiesTab->_aspect_ratio = frame_item->PropertiesTab->_height_fld->value()/fChoice;
                        break;
                }
				break;
			case HEIGHT:
				frame_item->PropertiesTab->_height_fld->setValue(fChoice);
                switch(frame_item->PropertiesTab->_aspect_ratio_fld->currentIndex())
                {
                    case QPUI_FIXED:
                        frame_item->PropertiesTab->_width_fld->setValue(fChoice/frame_item->PropertiesTab->_aspect_ratio);
                        break;

                    case QPUI_SQUARE_ASPECT:
                        page_ratio=frame_item->page()->aspectRatio();
                        frame_item->PropertiesTab->_width_fld->setValue(fChoice/page_ratio);
                        break;

                    case QPUI_ISOTROPIC:
                       frame_item->PropertiesTab->_width_fld->setValue(fChoice/frame_item->PropertiesTab->_aspect_ratio);
                        break;

                    default:
                        frame_item->PropertiesTab->_aspect_ratio = fChoice/frame_item->PropertiesTab->_width_fld->value();
                        break;
                }
				break;
			case ASPECT_RATIO:
				frame_item->PropertiesTab->_aspect_ratio_fld->setCurrentIndex(iChoice);
                if(iChoice==QPUI_SQUARE_ASPECT)
                {
                    page_ratio=frame_item->page()->aspectRatio();
                    frame_item->PropertiesTab->_width_fld->setValue(frame_item->PropertiesTab->_height_fld->value()/page_ratio);
                }
                if(iChoice==QPUI_ISOTROPIC)
                {
					double aspectRatio = frame_item->PropertiesTab->setIsotropicRatio();
					double newWidth = frame_item->PropertiesTab->_height_fld->value()/aspectRatio;
					double l_offset = frame_item->PropertiesTab->_loffset_fld->value();
					if (newWidth + l_offset > 0.99)
					{
						newWidth = 0.99 - l_offset;
						double newHeight = newWidth * aspectRatio;
                    	frame_item->PropertiesTab->_height_fld->setValue(newHeight);
					}

					frame_item->PropertiesTab->_width_fld->setValue(newWidth);
                }
				break;
			case FRAME_TYPE:
				frame_item->PropertiesTab->_frame_type_fld->setCurrentIndex(iChoice);
				break;
			//  Title Tab
			case AUTOTITLE:
				frame_item->TitleTab->_autotitle_fld->setChecked(bChoice);
				break;
			case TITLE:
				frame_item->TitleTab->_title_fld->setText(sChoice);
				frame_item->TitleTab->_autotitle_fld->setChecked(false);
				break;
			case TITLE_CHAR_SIZE:
				frame_item->TitleTab->_title_char_size_fld->setValue(fChoice);
				break;
			case TITLE_DISP:
				frame_item->TitleTab->_title_disp_fld->setValue(fChoice);
				break;
			case SUBTITLE:
				frame_item->TitleTab->_subtitle_fld->setText(sChoice);
				break;
			case SUBTITLE_CHAR_SIZE:
				frame_item->TitleTab->_subtitle_char_size_fld->setValue(fChoice);
				break;
			case SUBTITLE_DISP:
				frame_item->TitleTab->_subtitle_disp_fld->setValue(fChoice);
				break;
			case TITLE_JUST:
				frame_item->TitleTab->_title_just_fld->setCurrentIndex(iChoice);
				break;
			case TITLE_FONT_FAMILY:
				switch(iChoice)
				{
					case PL_FCI_SERIF:
						frame_item->TitleTab->_title_font_fld->setSerifFont();
						break;
					case PL_FCI_MONO:
						frame_item->TitleTab->_title_font_fld->setMonotypeFont();
						break;
					case PL_FCI_SCRIPT:
						frame_item->TitleTab->_title_font_fld->setDecorativeFont();
						break;
					default:
						frame_item->TitleTab->_title_font_fld->setSansFont();
						break;
				}
				break;
			case TITLE_FONT_STYLE:
				frame_item->TitleTab->_title_font_fld->setItalic(bChoice);
				break;
			case TITLE_FONT_WEIGHT:
				frame_item->TitleTab->_title_font_fld->setBold(bChoice);
				break;
			case TITLE_COLOUR:
			{
				QPalette line_palette = QPalette(QPUI_normal_palette);
				line_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				line_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				frame_item->TitleTab->_title_colour_fld->setPalette(line_palette);
				frame_item->_title_colour = cChoice;
				break;
			}
			case TICKS_CHAR_SIZE:
				frame_item->DisplayTab->_ticks_char_size_fld->setValue(fChoice);
				break;
			default:
				break;
				
		}
	} // end for over local list
}
		
		
void PlotList::setTraceOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;

	if(QuSlotDebug()) cout << "QpListView::setTraceOption" << endl;

	// apply Trace option to all selected traces (that belonging to visible tab is always selected)
	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		TraceItem* tr_item=dynamic_cast<TraceItem*>(item);
	   
		if(tr_item==NULL) continue;
	   
		// don't set trace for visible tab - user just did this - avoid infinite loop
		if(item==currentItem()) continue;
		if(tr_item->TraceTab->isVisible()) continue;
		if(tr_item->DataTab->isVisible()) continue;
		
        if(counter != thisCounter) continue; // overtaken by events, skip this one

		switch(option)
		{
			// Trace Tab
			case TRACE_LINE_STYLE:
			{
				tr_item->TraceTab->_line_style_fld->setCurrentIndex(iChoice);
				break;
			}
			case TRACE_LINE_WIDTH:
			{
				tr_item->TraceTab->_line_width_fld->setValue(fChoice);
				break;
			}
			case TRACE_CONNECT_STYLE: 
			{
				tr_item->TraceTab->_connect_style_fld->setCurrentIndex(iChoice);
				break;
			}
			case TRACE_LINE_SCALE:
			{
				tr_item->TraceTab->_line_scale_fld->setValue(fChoice);
				break;
			}
			case TRACE_LINE_COLOUR: 
			{
				QPalette line_palette = QPalette(QPUI_normal_palette);
				line_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				line_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				tr_item->TraceTab->_line_colour_fld->setPalette(line_palette);
				tr_item->_line_colour = cChoice;
				tr_item->userLineColour = true;
				break;
			}
			case TRACE_SYMBOL_SHAPE:
			{ 
				tr_item->TraceTab->_symbol_shape_fld->setCurrentIndex(iChoice);
				if(iChoice==20) // corresponds to "custom"
				{
					tr_item->TraceTab->_custom_symbol_fld->setEnabled(true);
				}
				else
				{
					tr_item->TraceTab->_custom_symbol_fld->setEnabled(false);
				}
				break;
			}
			case TRACE_CUSTOM_SYMBOL:
			{ 
				tr_item->TraceTab->_custom_symbol_fld->setText(sChoice);
				break;
			}
			case TRACE_SYMBOL_SIZE: 
			{
				tr_item->TraceTab->_symbol_size_fld->setValue(fChoice);
				break;
			}
			case TRACE_SYMBOL_COLOUR: 
			{
				QPalette line_palette = QPalette(QPUI_normal_palette);
				line_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				line_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				tr_item->TraceTab->_symbol_colour_fld->setPalette(line_palette);
				tr_item->_symbol_colour = cChoice;
				tr_item->userSymbolColour = true;
				break;
			}
			// Data Tab
			case TRACE_LEGEND_TEXT:
			{
				tr_item->DataTab->_legend_text_fld->setText(sChoice);
				break;
			}
			case TRACE_SHOW_LEGEND:
			{
				tr_item->DataTab->_show_legend_fld->setChecked(iChoice);
				break;
			}
			case TRACE_YDATA:
			{
				tr_item->replaceData(sChoice);
				break;
			}
			case TRACE_YCOMP:
			{
				tr_item->replaceComponent(sChoice);
				break;
			}
			case TRACE_TIDATA:
			{
				tr_item->replaceTIdata(sChoice);
				break;
			}
			case TRACE_TICOMP:
			{
				tr_item->replaceTIcomp(sChoice);
				break;
			}
			case TRACE_XDATA:
			{
				tr_item->replaceXData(sChoice);
				break;
			}
			case TRACE_XCOMP:
			{
				tr_item->replaceXComponent(sChoice);
				break;
			}
			case LEGEND_AUTO_TEXT:
			{
				tr_item->DataTab->_auto_legend_fld->setChecked(bChoice);
				break;
			}
            case TRACE_GAP_DETECTION:
            {
                tr_item->DataTab->_gap_detection_fld->setChecked(bChoice);
                break;
            }
            case TRACE_GAP_THRESHOLD:
            {
                tr_item->DataTab->_gap_threshold_fld->setValue(fChoice);
                break;
            }
            case TRACE_GAP_THRESHOLD_TYPE:
            {
                tr_item->DataTab->_gap_threshold_type_fld->setCurrentIndex(iChoice);
                break;
            }
            case TRACE_COL_COMP:
            {
				tr_item->replace_C_Component(sChoice);
                break;
            }
            case TRACE_COL_DATA:
            {
				tr_item->replaceCdata(sChoice);
                break;
            }
            case TRACE_COL_MIN:
            {
				tr_item->TraceTab->_c_min_fld->setText(sChoice);
                break;
            }
            case TRACE_COL_MAX:
            {
				tr_item->TraceTab->_c_max_fld->setText(sChoice);
                break;
            }
            case TRACE_SHOW_COL_BAR:
            {
				tr_item->TraceTab->_show_colour_bar->setChecked(bChoice);
                break;
            }
            case TRACE_AUTO_COL_BAR:
            {
				tr_item->TraceTab->c_range_auto->setChecked(bChoice);
                break;
            }
            case TRACE_LOG_COL_BAR:
            {
				tr_item->TraceTab->c_range_log->setChecked(bChoice);
                break;
            }
            case TRACE_SET_C_SIZE:
            {
				tr_item->TraceTab->_size_on->setChecked(bChoice);
                break;
            }
            case TRACE_SET_C_COL:
            {
				tr_item->TraceTab->_colour_on->setChecked(bChoice);
                break;
            }
            case TRACE_EXP_COL_BAR_X:
            {
				tr_item->TraceTab->_exp_label_offset_x->setValue(fChoice);
                break;
            }
            case TRACE_EXP_COL_BAR_Y:
            {
				tr_item->TraceTab->_exp_label_offset_y->setValue(fChoice);
                break;
            }
            case TRACE_SET_COL_TABLE_PROF:
            {
				tr_item->TraceTab->colourTable->setProfilePalette(iChoice);
                break;
            }
            case TRACE_SET_COL_TABLE_SESS:
            {
				tr_item->TraceTab->colourTable->setSessionPalette(iChoice);
                break;
            }
            case TRACE_SET_COL_TABLE_STD:
            {
				tr_item->TraceTab->colourTable->setStdPalette(iChoice);
                break;
            }
            case TRACE_USER_COL_LAB:
            {
				tr_item->TraceTab->colLabSlot->setText(sChoice);
                break;
            }
            case TRACE_COL_BAR_W:
            {
				tr_item->TraceTab->_colour_bar_width->setValue(fChoice);
                break;
            }
            case TRACE_COL_BAR_H:
            {
				tr_item->TraceTab->_colour_bar_height->setValue(fChoice);
                break;
            }
            case TRACE_COL_BAR_HOFF:
            {
				tr_item->TraceTab->_colour_bar_disp->setValue(fChoice);
                break;
            }
            case TRACE_COL_BAR_VOFF:
            {
				tr_item->TraceTab->_colour_bar_voffset->setValue(fChoice);
                break;
            }
            case TRACE_COL_BAR_TICK:
            {
				tr_item->TraceTab->_colourscale_ticklength->setValue(fChoice);
                break;
            }
			default:
				break;	  
		}
   }
   
}

		
void PlotList::setEventOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;

	if(QuSlotDebug()) cout << "PlotList::setEventOption" << endl;

	// apply Event option to all selected events (that belonging to visible tab is always selected)

	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		EventItem* ev_item=dynamic_cast<EventItem*>(item);
    
		if(!ev_item) continue;
	  
		// don't set event for visible tab - user just did this - avoid infinite loop
		if(ev_item->eventTab->isVisible()) continue;
 
        if(counter != thisCounter) continue; // overtaken by events, skip this one
	  
		switch(option)
		{
			case EVENT_Y_DATA:
				ev_item->eventTab->_y_data_fld->setText(sChoice);
				ev_item->eventTab->_y_data_fld->reValidate(true);
				break;
			case EVENT_X_DATA:
				ev_item->eventTab->_x_data_fld->setText(sChoice);
				ev_item->eventTab->_x_data_fld->reValidate(true);
				break;
			case EVENT_LABEL:
				ev_item->eventTab->_event_label_fld->setText(sChoice);
				break;
			case EVENT_LABEL_CHAR_SIZE: 
				ev_item->eventTab->_char_size_fld->setValue(fChoice);
                break;
            case EVENT_LABEL_JUST:
                ev_item->eventTab->_event_label_just_fld->setValue(fChoice);
                break;
			case EVENT_LABEL_FONT_FAMILY:
				switch(iChoice)
				{
					case PL_FCI_SERIF:
						ev_item->eventTab->_event_label_font_fld->setSerifFont();
						break;
					case PL_FCI_MONO:
						ev_item->eventTab->_event_label_font_fld->setMonotypeFont();
						break;
					case PL_FCI_SCRIPT:
						ev_item->eventTab->_event_label_font_fld->setDecorativeFont();
						break;
					default:
						ev_item->eventTab->_event_label_font_fld->setSansFont();
						break;
				}
				break;
			case EVENT_LABEL_FONT_STYLE:
				ev_item->eventTab->_event_label_font_fld->setItalic(bChoice);
				break;
			case EVENT_LABEL_FONT_WEIGHT:
				ev_item->eventTab->_event_label_font_fld->setBold(bChoice);
				break;
			case EVENT_LABEL_COLOUR: 
			{
				QPalette label_palette = QPalette(QPUI_normal_palette);
				label_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				label_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				ev_item->eventTab->_event_label_colour_fld->setPalette(label_palette);
				ev_item->_event_label_colour = cChoice;
				break;
			}
			default:
				break;
			  
		}
	}
}


void PlotList::setSpectrumOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{        
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;
    
	if(QuSlotDebug()) cout << "PlotList::setSpectrumOption" << endl;
	// apply Spectrum option to all selected spectra (that belonging to visible tab is always selected)
       
	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{        
		QpuiItem* item = (QpuiItem*) treeItem;
		SpectrumItem* sp_item=dynamic_cast<SpectrumItem*>(item);
		
		if( !sp_item) continue;
		
		// don't set spectrum for visible tab - user just did this - avoid infinite loop
		if(sp_item->DataTab->isVisible()) continue;
		if(sp_item->ColourscaleTab->isVisible()) continue;
 
        if(counter != thisCounter) continue; // overtaken by events, skip this one

		switch(option)
		{
			// Spectrum Data Tab
			case SPECTROGRAM_ZDATA:

				sp_item->replaceData(sChoice);

				break;
			case SPECTROGRAM_ZCOMP:

				sp_item->replaceComponent(sChoice);

				break;
			case SPECTROGRAM_TIDATA:
			{
				sp_item->replaceTIdata(sChoice);
				break;
			}
			case SPECTROGRAM_TICOMP:
			{
				sp_item->replaceTIcomp(sChoice);
				break;
			}
			case SPECTROGRAM_YDATA_START:
				// sChoice will be either component selection or object base name
				if(sChoice.contains("["))
				{
					// change component
					DvString newName = baseObjectText( sp_item->DataTab->_y_start_data_fld->text().toLatin1().data() );
					newName += sChoice.toLatin1().data();
					sp_item->DataTab->_y_start_data_fld->setText(newName.c_str());
				}
				else
				{
					sp_item->DataTab->_y_start_data_fld->setTextKeepComp(sChoice);
				}		
				sp_item->DataTab->_y_start_data_fld->reValidate(true);
	
				break;
			case SPECTROGRAM_YDATA_END:
				/*
				// sChoice will be either component selection or object base name
				if(sChoice.contains("["))
				{
					// change component
					QString newName = baseObjectText( sp_item->DataTab->_y_end_data_fld->text() );
					newName += sChoice;
					sp_item->DataTab->_y_end_data_fld->setText(newName);
				}
				else
				{
					sp_item->DataTab->_y_end_data_fld->setTextKeepComp(sChoice);
				}
				sp_item->DataTab->_y_end_data_fld->reValidate(true);	
				*/
				break;
			case SPECTROGRAM_XDATA_START:
				// sChoice will be either component selection or object base name
				if(sChoice.contains("["))
				{
					// change component
					DvString newName = baseObjectText( sp_item->DataTab->_x_start_data_fld->text().toLatin1().data() );
					newName += sChoice.toLatin1().data();
					sp_item->DataTab->_x_start_data_fld->setText(newName.c_str());
				}
				else
				{
					sp_item->DataTab->_x_start_data_fld->setTextKeepComp(sChoice);
				}			
				sp_item->DataTab->_x_start_data_fld->reValidate(true);
				break;
			case SPECTROGRAM_XY_SWAP:
				
				sp_item->DataTab->_XYtoggle->toggle();
				
				sp_item->DataTab->setXYswap();
				
				break;
			case SPECTROGRAM_XDATA_END:
				/*
				// sChoice will be either component selection or object base name
				if(sChoice.contains("["))
				{
					// change component
					QString newName = baseObjectText( sp_item->DataTab->_x_end_data_fld->text() );
					newName += sChoice;
					sp_item->DataTab->_x_end_data_fld->setText(newName);
				}
				else
				{
					sp_item->DataTab->_x_end_data_fld->setTextKeepComp(sChoice);
				}	
				sp_item->DataTab->_x_end_data_fld->reValidate(true);
				*/
				break;
			case COLOUR_SCALE_MIN:
				sp_item->ColourscaleTab->_colourscale_min_fld->setDouble(fChoice);
				sp_item->ColourscaleTab->_colourscale_auto_fld->setCurrentIndex(QP_FROM_USER);
				sp_item->ColourscaleTab->setSlotColour(true);
				sp_item->ColourscaleTab->_colourscale_min_fld->lineBox->setPalette(sp_item->ColourscaleTab->GUIpalette);
				sp_item->ColourscaleTab->_colourscale_max_fld->lineBox->setPalette(sp_item->ColourscaleTab->GUIpalette);
				break;
			case COLOUR_SCALE_MAX:
				sp_item->ColourscaleTab->_colourscale_max_fld->setDouble(fChoice);
				sp_item->ColourscaleTab->_colourscale_auto_fld->setCurrentIndex(QP_FROM_USER);
				sp_item->ColourscaleTab->setSlotColour(true);
				sp_item->ColourscaleTab->_colourscale_min_fld->lineBox->setPalette(sp_item->ColourscaleTab->GUIpalette);
				sp_item->ColourscaleTab->_colourscale_max_fld->lineBox->setPalette(sp_item->ColourscaleTab->GUIpalette);
				break;
			case COLOUR_SCALE_TICK_LENGTH:
				sp_item->ColourscaleTab->_colourscale_ticklength_fld->setValue(fChoice);
				break;
			case COLOUR_SCALE_LABEL:
				sp_item->ColourscaleTab->_colourscale_label_fld->setText(sChoice);
				sp_item->ColourscaleTab->_colourscale_autolabel_fld->setChecked(false);
				break;
			case COLOUR_SCALE_AUTOSCALE:
				sp_item->ColourscaleTab->_colourscale_auto_fld->setCurrentIndex(iChoice);
				sp_item->ColourscaleTab->setColourscaleMinMax();
				break;
			case COLOUR_SCALE_AUTOLABEL:
				sp_item->ColourscaleTab->_colourscale_autolabel_fld->setChecked(bChoice);
				sp_item->ColourscaleTab->setColourScaleAutoLabel();
				break;
			case COLOUR_SCALE_LINLOG:
				sp_item->ColourscaleTab->_colourscale_linlog_fld->setCurrentIndex(iChoice);
				sp_item->ColourscaleTab->_colourscale_auto_fld->setCurrentIndex(QP_FROM_USER);
				break;
			case COLOUR_SCALE_SHOW_COLOUR_BAR:
				sp_item->ColourscaleTab->_colourscale_show_colour_bar_fld->setChecked(bChoice);
				break;
			case COLOUR_SCALE_COLOUR_BAR_WIDTH:
				sp_item->ColourscaleTab->_colourscale_colour_bar_width_fld->setValue(fChoice);
				break;
			case COLOUR_SCALE_COLOUR_BAR_HEIGHT:
				sp_item->ColourscaleTab->_colourscale_colour_bar_height_fld->setValue(fChoice);
				break;
			case COLOUR_SCALE_COLOUR_BAR_VOFFSET:
				sp_item->ColourscaleTab->_colourscale_colour_bar_voffset_fld->setValue(fChoice);
				break;
			case COLOUR_SCALE_COLOUR_BAR_DISP:
				sp_item->ColourscaleTab->_colourscale_colour_bar_disp_fld->setValue(fChoice);
				break;
// 			case COLOUR_SCALE_TABLE:
// 				sp_item->ColourscaleTab->_colourscale_table_fld->setCurrentItem(iChoice);
// 				break;
            case COLOUR_SCALE_TABLE_STD:
                sp_item->ColourscaleTab->_colourtable_fld->setStdPalette(iChoice);
                break;
            case COLOUR_SCALE_TABLE_PROFILE:
                sp_item->ColourscaleTab->_colourtable_fld->setProfilePalette(iChoice);
                break;
            case COLOUR_SCALE_TABLE_SESSION:
                sp_item->ColourscaleTab->_colourtable_fld->setSessionPalette(iChoice);
                break;
            case COLOUR_SCALE_AXIS_EXP_LABEL_X:
                sp_item->ColourscaleTab->_exp_label_offset_x_fld->setValue(fChoice);
                break;
            case COLOUR_SCALE_AXIS_EXP_LABEL_Y:
                sp_item->ColourscaleTab->_exp_label_offset_y_fld->setValue(fChoice);
                break;
            case SPECTROGRAM_INTERLACE:
                sp_item->DataTab->interlace_toggle->setChecked(bChoice);
                break;
            case SPECTROGRAM_GAP:
                sp_item->DataTab->gap_toggle->setChecked(bChoice);
                break;
            case SPECTROGRAM_MIN_CELL_WIDTH:
                sp_item->DataTab->minCellWidth->setValue(fChoice);
                break;
			default:
				break;
				
		}
	} // end for over local list

}

	
void PlotList::setLegendOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;

	if(QuSlotDebug()) cout << "PlotList::setLegendOption" << endl;
	// Slot called when value changed on legend tab

	// apply Legend option to all selected panels (that belonging to visible tab is always selected)

	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		PanelItem* panel_item=dynamic_cast<PanelItem*>(item);
    
		if( !panel_item) continue;
		
		if(panel_item->LegendTab->isVisible()) continue;
	  
        if(counter != thisCounter) continue; // overtaken by events, skip this one
		switch(option)
		{
			case SHOW_LEGEND:
			{
				panel_item->LegendTab->_show_legend_fld->setChecked(bChoice);
				break;
			}
			case LEGEND_BORDER:
			{
				panel_item->LegendTab->_legend_border_fld->setCurrentIndex(iChoice);
				break;
			}
			case LEGEND_NUM_ROWS:
			{
				panel_item->LegendTab->_legend_num_rows_fld->setValue(iChoice);
				int num_traces = panel_item->numberTraces();
				int num_rows = iChoice;
				int num_cols = (int)ceil((float)num_traces / num_rows);
				panel_item->LegendTab->_legend_num_cols_fld->setValue(num_cols);
				break;
			}
			case LEGEND_NUM_COLS:
			{
				panel_item->LegendTab->_legend_num_cols_fld->setValue(iChoice);
				int num_traces = panel_item->numberTraces();
				int num_cols = iChoice;
				int num_rows = (int)ceil((float)num_traces / num_cols);
				panel_item->LegendTab->_legend_num_rows_fld->setValue(num_rows);
				break;
			}
			case LEGEND_CHAR_SIZE:
			{
				panel_item->LegendTab->_legend_char_size_fld->setValue(fChoice);
				break;
			}
			case LEGEND_MAX_CHAR_LENGTH:
			{
				panel_item->LegendTab->_legend_max_char_length_fld->setValue(iChoice);
				break;
			}
			case LEGEND_LINE_LENGTH:
			{
				panel_item->LegendTab->_legend_line_length_fld->setValue(fChoice);
				break;
			}
			case LEGEND_JUST:
			{
				panel_item->LegendTab->_legend_just_fld->setCurrentIndex(iChoice);
				break;
			}
			case LEGEND_FONT_FAMILY:
			{
				switch(iChoice)
				{
					case PL_FCI_SERIF:
						panel_item->LegendTab->_legend_font_fld->setSerifFont();
						break;
					case PL_FCI_MONO:
						panel_item->LegendTab->_legend_font_fld->setMonotypeFont();
						break;
					case PL_FCI_SCRIPT:
						panel_item->LegendTab->_legend_font_fld->setDecorativeFont();
						break;
					default:
						panel_item->LegendTab->_legend_font_fld->setSansFont();
						break;
				}
				break;
			}
			case LEGEND_FONT_STYLE:
				panel_item->LegendTab->_legend_font_fld->setItalic(bChoice);
				break;
			case LEGEND_FONT_WEIGHT:
				panel_item->LegendTab->_legend_font_fld->setBold(bChoice);
				break;
			case LEGEND_ALIGN:
			{
				panel_item->LegendTab->_legend_align_fld->setCurrentIndex(iChoice);
				break;
			}
			case LEGEND_L_OFFSET:
			{
				panel_item->LegendTab->_legend_loffset_fld->setValue(fChoice);
				break;
			}
			case LEGEND_T_OFFSET:
			{
				panel_item->LegendTab->_legend_toffset_fld->setValue(fChoice);
				break;
			}
			case LEGEND_BACKGROUND:
			{
				panel_item->LegendTab->_legend_background_fld->setCurrentIndex(iChoice);
				break;
			}
			case LEGEND_WIDTH:
			{
				panel_item->LegendTab->_legend_width_fld->setValue(fChoice);

				switch(panel_item->LegendTab->_legend_align_fld->currentIndex())	
				{
					case QPUI_INSIDE_TOP_RIGHT:
					case QPUI_INSIDE_BOTTOM_RIGHT:
						panel_item->LegendTab->_legend_loffset_fld->setValue(1.-fChoice);
						break;
						
					case QPUI_ABOVE_TOP_CENTRE:
						panel_item->LegendTab->_legend_loffset_fld->setValue(0.5-fChoice/2.);
						break;
					
					default:
						break;
				}
				break;
			}
			case LEGEND_HEIGHT:
			{
				panel_item->LegendTab->_legend_height_fld->setValue(fChoice);

				switch(panel_item->LegendTab->_legend_align_fld->currentIndex())	
				{
					case QPUI_INSIDE_BOTTOM_LEFT:
					case QPUI_INSIDE_BOTTOM_RIGHT:
						panel_item->LegendTab->_legend_toffset_fld->setValue(1.-fChoice);
						break;
					
					default:
						break;
				}
				break;
			}
		}
	} // end for over selected list
}
		

void PlotList::setTLabDataOption(int option, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
    // stop interlacing of calls with fast typing
    static int counter=0;
    counter ++;
    int thisCounter=counter;

	if(QuSlotDebug()) cout << "PlotList::setTLabDataOption" << endl;

	// apply Trace option to all selected traces (that belonging to visible tab is always selected)
	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		TLabItem* tlab_item=dynamic_cast<TLabItem*>(item);
	   
		if(tlab_item==NULL) continue;
	   
		// don't set for visible tab - user just did this - avoid infinite loop
		if(item==currentItem()) continue;
		
		if(tlab_item->TLabDataTab->isVisible()) continue;
		
        if(counter != thisCounter) continue; // overtaken by events, skip this one
		switch(option)
		{
			case T_LAB_DATA_XDATA:
			{
				tlab_item->replaceXData(sChoice);
				break;
			}
			case T_LAB_DATA_XCOMP:
			{
				tlab_item->replaceXComponent(sChoice);
				break;
			}
			case T_LAB_DATA_META:
			{
				tlab_item->TLabDataTab->metaText->setText(sChoice);
				if(sChoice.isEmpty()) tlab_item->TLabDataTab->UserText = false;
				else tlab_item->TLabDataTab->UserText = true;
				break;
			}
			case T_LAB_DATA_UNITS:
			{
				tlab_item->TLabDataTab->unitText->setText(sChoice);
				if(sChoice.isEmpty()) tlab_item->TLabDataTab->UserUnit = false;
				else tlab_item->TLabDataTab->UserUnit = true;
				break;
			}
			case T_LAB_DATA_POWER:
			{
				tlab_item->TLabDataTab->powText->setValue(fChoice);
				break;
			}
			case T_LAB_DATA_OFFSET:
			{
				tlab_item->TLabDataTab->_offset_y_fld->setValue(fChoice);
				break;
			}
			case T_LAB_DATA_CHAR:
			{
				tlab_item->TLabDataTab->_label_char_size_fld->setValue(fChoice);
				break;
			}
			case T_LAB_DATA_LAB_VERT:
			{
				tlab_item->TLabDataTab->_label_V_fld->setChecked(bChoice);
				break;
			}
			case T_LAB_DATA_UNIT_VERT:
			{
				tlab_item->TLabDataTab->_unit_V_fld->setChecked(bChoice);
				break;
			}
			case T_LAB_DATA_FONT_FAMILY:
			{
    		    switch(iChoice)
				{
        			case PL_FCI_SERIF: tlab_item->TLabDataTab->_label_font_fld->setSerifFont(); break;
        			case PL_FCI_MONO: tlab_item->TLabDataTab->_label_font_fld->setMonotypeFont(); break;
        			case PL_FCI_SCRIPT: tlab_item->TLabDataTab->_label_font_fld->setDecorativeFont(); break;
        			default: tlab_item->TLabDataTab->_label_font_fld->setSansFont(); break;
    			}
				break;
			}
			case T_LAB_DATA_FONT_STYLE:
			{
    			tlab_item->TLabDataTab->_label_font_fld->setItalic(bChoice);
				break;
			}
			case T_LAB_DATA_FONT_WEIGHT:
			{
    			tlab_item->TLabDataTab->_label_font_fld->setBold(bChoice);
				break;
			}
			case T_LAB_DATA_COLOUR:
			{	
				QPalette label_palette = QPalette(QPUI_normal_palette);
				label_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				label_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				tlab_item->TLabDataTab->_label_colour_fld->setPalette(label_palette);
				tlab_item->TLabDataTab->_label_colour = cChoice;
				break;
			}

			default:
				break;	  
		}
   }
   
}


void PlotList::setYRangeAllSelected()
{
	if(QuSlotDebug()) cout << "QpListView::setYRangeAllSelected" << endl;

	double from = 1.e31;
	double to = -1.e31;
	
	// find min/max for selected panels
	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		PanelItem * panel_item = dynamic_cast<PanelItem*>(item);
		if( !panel_item) continue;
			
		double panelFrom, panelTo;
		bool found = panel_item->getYRange(panelFrom, panelTo);

		if(found) {
			if(from > panelFrom) from = panelFrom;
			if(to < panelTo) to = panelTo;
		}
	}
	
	if( from > to) return;

	// set range on selected panels
	foreach(QTreeWidgetItem* item, list)
	{
		PanelItem * panel_item = dynamic_cast<PanelItem*>(item);
		if( !panel_item) continue;
		
		panel_item->yAxisTab->_axis_xy_fld->setInterval(from, to);
	}
	
	return;
	
}


void PlotList::setAxisOption(int option, int axis, int iChoice, float fChoice, const QString& sChoice, bool bChoice, const QColor& cChoice)
{
	// Slot called when value changed on axis option tabs
	// axis identifies which of X,Y or T is changed.
	
	if(QuSlotDebug()) cout << "PlotList::setAxisOption" << endl;

	QpAxisTab * axisTab = 0;
	// apply axis option to all selected frames or panels (that belonging to visible tab is always selected)

	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;

		// if Y axis only modify panel items
		if(axis == Y_AXIS)
		{
			PanelItem * panel_item = dynamic_cast<PanelItem*>(item);
			if( !panel_item) continue;
			
			axisTab = panel_item->yAxisTab;
		}
		else if(axis == X_AXIS){
			FrameItem * frame_item = dynamic_cast<FrameItem*>(item);
			if( !frame_item) continue;

			axisTab = frame_item->xAxisTab;
		}
		else if(axis == T_AXIS){
			FrameItem * frame_item = dynamic_cast<FrameItem*>(item);
			if( !frame_item) continue;
			
			axisTab = frame_item->tAxisTab;
		}
		else break;
		
		// don't set axis for visible tab - user just did this - avoid infinite loop

		if(axisTab->isVisible()) continue;

		switch(option)
		{
			case AXIS_AUTOSCALE:	
			{
				axisTab->handleAutoScale(iChoice);
				axisTab->setAxisMinMax();
				break;
			}
			case AXIS_LINLOG:	
			{
				// only called for X or Y axis	
				axisTab->handleAutoScale(QP_FROM_USER);
				axisTab->_axis_linlog_fld->setCurrentIndex(iChoice);
				break;
			}
			case AXIS_MIN:
			{
				axisTab->handleAutoScale(QP_FROM_USER);
				if(axisTab->I_axis!=T_AXIS)
				{
					axisTab->_axis_xy_fld->setStart(sChoice.toDouble());

					axisTab->_axis_xy_fld->setAltPalette(false);
				}
				else
				{
					axisTab->_axis_time_fld->setStart(DvTime(sChoice.toLatin1().data()));

					axisTab->_axis_time_fld->setAltPalette(false);
					axisTab->setSlotColour(false);
					axisTab->_t_data_fld->lineBox->setPalette(axisTab->GUIpalette);
				}
				break;
			}
			case AXIS_MAX:
			{
				axisTab->handleAutoScale(QP_FROM_USER);
				if(axisTab->I_axis!=T_AXIS)
				{
					axisTab->_axis_xy_fld->setEnd(sChoice.toDouble());

					axisTab->_axis_xy_fld->setAltPalette(false);
				}
				else
				{
					axisTab->_axis_time_fld->setEnd(DvTime(sChoice.toLatin1().data()));

					axisTab->_axis_time_fld->setAltPalette(false);
					axisTab->setSlotColour(false);
					axisTab->_t_data_fld->lineBox->setPalette(axisTab->GUIpalette);
				}
				break;
			}
			case AXIS_NUM_MAJOR_TICKS:			
			{
				axisTab->_axis_major_ticks_num_fld->setValue(iChoice);
				break;
			}
			case AXIS_NUM_MINOR_TICKS:			
			{
				axisTab->_axis_minor_ticks_num_fld->setValue(iChoice);
				break;
			}
			case AXIS_MAJOR_TICKMARKS:			
			{
				axisTab->_axis_major_tickmarks_fld->setCurrentIndex(iChoice);
				break;
			}
			case AXIS_MINOR_TICKMARKS:			
			{
				axisTab->_axis_minor_tickmarks_fld->setCurrentIndex(iChoice);
				break;
			}
			case AXIS_LABEL:			
			{
				axisTab->_label_fld->setText(sChoice);
				break;
			}
			case AXIS_LABEL_CHAR_SIZE:			
			{
				axisTab->_label_char_size_fld->setValue(fChoice);
				break;
			}
			case AXIS_LABEL_DISP:			
			{
				axisTab->_label_disp_fld->setValue(fChoice);
				break;
			}
			case AXIS_AUTOLABEL:			
			{
				axisTab->_axis_autolabel_fld->setChecked(bChoice);
				axisTab->setAutoLabelText();
				break;
			}
			case AXIS_LABEL_ROTATION:			
			{
				axisTab->_label_rotation_fld->setValue(fChoice);
				break;
			}
			case AXIS_LABEL_FONT_FAMILY:			
			{
				switch(iChoice)
				{
					case PL_FCI_SERIF:
						axisTab->_label_font_fld->setSerifFont();
						break;
					case PL_FCI_MONO:
						axisTab->_label_font_fld->setMonotypeFont();
						break;
					case PL_FCI_SCRIPT:
						axisTab->_label_font_fld->setDecorativeFont();
						break;
					default:
						axisTab->_label_font_fld->setSansFont();
						break;
				}
				break;
			}
			case AXIS_LABEL_FONT_STYLE:
				axisTab->_label_font_fld->setItalic(bChoice);
				break;
			case AXIS_LABEL_FONT_WEIGHT:
				axisTab->_label_font_fld->setBold(bChoice);
				break;
			case AXIS_LABEL_COLOUR:	
			{
				QPalette label_palette = QPalette(QPUI_normal_palette);
				label_palette.setColor(QPalette::Active, QPalette::ButtonText, cChoice);
				label_palette.setColor(QPalette::Inactive, QPalette::ButtonText, cChoice);
				axisTab->_label_colour_fld->setPalette(label_palette);
				axisTab->_label_colour = cChoice;
				break;
			}
			case AXIS_T_DATA:	
			{
				// only called for T axis
				axisTab->_t_data_fld->setText(sChoice);
				axisTab->_t_data_fld->reValidate(true);
				axisTab->setTfromObj();
				break;
			}
			case AXIS_TICK_TIME_FORMAT:
			{
				// only called for T axis
				axisTab->tick_time_fmt_fld->setText(sChoice);
				break;
			}
			case AXIS_TICK_TIME_FORMAT_AUTO:
			{
				// only called for T axis
				axisTab->tick_time_fmt_auto_fld->setChecked(iChoice);
				axisTab->tick_time_fmt_fld->setReadOnly(iChoice);
				axisTab->tick_time_fmt_fld->setEnabled(!iChoice);
				break;
			}
			case AXIS_TIME_LABELS_FORMAT:
			{
				// only called for T axis
				axisTab->time_labels_fmt_fld->setText(sChoice);
				break;
			}
			case AXIS_TIME_LABELS_FORMAT_AUTO:
			{
				// only called for T axis
				axisTab->time_labels_fmt_auto_fld->setChecked(iChoice);
				axisTab->time_labels_fmt_fld->setReadOnly(iChoice);
				axisTab->time_labels_fmt_fld->setEnabled(!iChoice);
				break;
			}
            case AXIS_EXP_LABEL_Y:
            {
                axisTab->_exp_label_offset_y_fld->setValue(fChoice);
                break;
            }
            case AXIS_EXP_LABEL_X:
            {
                axisTab->_exp_label_offset_x_fld->setValue(fChoice);
                break;
            }
		}
	} // end for over local list
}

// ------------------------

void PlotList::setPlotOption(int option, bool bChoice)
{
	if(QuSlotDebug()) cout << "PlotList::setPlotOption" << endl;

	// apply Trace option to all selected traces (that belonging to visible tab is always selected)

	QList<QTreeWidgetItem*> list = selectedItems();
	foreach(QTreeWidgetItem* treeItem, list)
	{
		QpuiItem* item = (QpuiItem*) treeItem;
		PlotItem* pl_item=dynamic_cast<PlotItem*>(item);
    
		if( !pl_item) continue;
	  
		// don't set option for visible tab - user just did this - avoid infinite loop
		if(pl_item->DataTab->isVisible()) continue;
	  
	  
		switch(option){
			// Data Tab
			default: case USE_TIME_AS_SEC:
			{
				pl_item->DataTab->timeAsSec_toggle->setChecked(bChoice);
				break;
			}
		}
	}
}

// ------------------------

void PlotList::deleteSelectedItems()
{
	if(QuSlotDebug()) cout << "PlotList::deleteSelectedItems" << endl;fflush(stdout);

	// deleting items affects the QModelIndex List, so collect items

	QList <QTreeWidgetItem*> itemList = selectedItems();

	clearSelection();
	
	QList <QTreeWidgetItem*> deleteList;

	// find highest level items
	for(int i=0; i<itemList.size(); i++)
	{
		QpuiItem *item = (QpuiItem *) itemList.at(i);
		if( !item->ancestorInList(itemList) ) deleteList.push_back(item);
	}
	
	// now finally safe to start deleting
	for(int i=0; i<deleteList.size(); i++)
	{
		deleteItem((QpuiItem *) deleteList.at(i));
	}

}

// ------------------------

void PlotList::deleteAllItems()
{
	if(QuSlotDebug()) cout << "PlotList::deleteAllItems" << endl;
	
	this->clear();

}

// ------------------------

void PlotList::renameSelectedItem()
{
	if(QuSlotDebug()) cout << "PlotList::renameSelectedItem" << endl;
	
	if(currentItem() != NULL) {
		QpuiItem* item = dynamic_cast <QpuiItem*> (currentItem());
		editItem(currentItem());
		if(item){
			item->userSetName = true;
		}
	}
}

// ------------------------

void PlotList::linkSelected()
{
	if(QuSlotDebug()) cout << "PlotList::linkSelected" << endl;

	QList<PlotItem*> list;
	QList<QTreeWidgetItem*> selectedList=selectedItems();
	
	foreach(QTreeWidgetItem* qpuiItem, selectedList)
	{
		PlotItem* item = dynamic_cast<PlotItem*>(qpuiItem);
		if(item!=NULL) list.push_back(item);
	}
	
	if(!list.empty()) linkPlots(list);
}

// ------------------------

void PlotList::unlinkSelected()
{
	
	if(QuSlotDebug()) cout << "PlotList::unlinkSelected" << endl;

	QList<QTreeWidgetItem*> list=selectedItems();
	foreach(QTreeWidgetItem* qpuiItem, list)
	{
		PlotItem* item=dynamic_cast<PlotItem*>(qpuiItem);
		if(item!=NULL)
		{
			foreach(PlotItem* temp, item->linkedPlots)
			{
				temp->linkedPlots.removeAll(item);
			}
			item->linkedPlots.clear();
			item->setLinkText("");
		}
	}
}

// ------------------------

void PlotList::setPlotType(QAction *act)
{
	if(QuSlotDebug()) cout << "PlotList::setPlotType" << endl;

	QpItemType plotType = QP_TRACE;
	if(act->text() == QString("Spectrogram") )plotType = QP_SPECTROGRAM;
	else if(act->text() == QString("Const X or T Trace") )plotType = QP_CONST_XT;
	else if(act->text() == QString("Const Y Trace") )plotType = QP_CONST_Y;
	else if(act->text() == QString("Regression Line") )plotType = QP_REG_LINE;
	 
	if(QuSlotDebug()) cout << "PlotView::setPlotType" << endl;
	

	if(itemFromTab != NULL) changePlotType(itemFromTab, plotType);
	
}

// ------------------------

void PlotList::setFrameType(QAction *act)
{
	if(QuSlotDebug()) cout << "PlotList::setFrameType" << endl;
	
	int frameType = QP_TS;
	if(act->text() == QString("XY Frame") ) frameType = QP_XY;
	
	QList<QTreeWidgetItem*> list=selectedItems();
	foreach(QTreeWidgetItem* item, list)
	{
		FrameItem* frameItem=dynamic_cast<FrameItem*>(item);
		
		PlotItem* plotItem=dynamic_cast<PlotItem*>(item);
		
		if(frameItem!=NULL) frameItem->changeFrame(frameType);
		else if(plotItem!=NULL) plotItem->frame()->changeFrame(frameType);
		
	}
	updateOnSelection();

}
// ---------------- 

bool PlotList::isAncestorOf(QpuiItem* other)
{
	// go through pages to see if any are ancestor of other
	for(int i=0; i<topLevelItemCount(); i++)
	{
		if( ((QpuiItem*)topLevelItem(i))->isAncestorOf(other)) return true;
	}
	return false;
}
// ---------------- 

void PlotList::setPageLayout(PageItem *pageItem)
{
	if(QuSlotDebug())
	{
		printf("PlotList::setPageLayout \n");
		fflush(stdout);
	}
	
	// tell pages to redo layout
	if(pageItem)
	{
		pageItem->LayoutTab->updateRowCol(pageItem->childCount());
	}
	
}
// -------------------------------

void PlotList::displayIntervalWidget(double x, double y, int pos_x, int pos_y)
{
	if ( QuSlotDebug() ) printf( "PlotList::displayIntervalWidget \n" );

	PlotWindow* win=(PlotWindow *) sender();
	if(!win) return;
	
    win->ownerGUI->currentWindow = win;
    win->ownerGUI->setCurrentIndex(win->ownerGUI->indexOf(win->getId()));
    
	win->setPLFocus(); // ensure we are plotting to and reading from same window
	
	// Search if clicked inside a frame
	FrameItem * selectedFrame=0;
	int nPanel=0;
	FrameItem* frameItem;
	bool alreadyVisible = win->intervalDialog->isVisible();
	
	for(int p=0; p<topLevelItemCount()&& selectedFrame == 0; p++)
	{
		PageItem *_page = (PageItem*) topLevelItem(p);
        
        if(_page->PageTab->_xwin_num_fld->currentWindow != win) continue;
           
		for(int i=0; i<_page->childCount() ; ++i)
		{
			frameItem=dynamic_cast<FrameItem*>(_page->child(i));
			
			int numPanels = frameItem->childCount();
			bool hasSpectrum = _page->containsSpectrum();
			double factor=(hasSpectrum?0.9:1.);
			if(frameItem->PropertiesTab->_loffset_fld->value() <= x &&  
						x <= frameItem->PropertiesTab->_loffset_fld->value() + frameItem->PropertiesTab->_width_fld->value()*factor && 
						frameItem->PropertiesTab->_toffset_fld->value()<= y &&
						y <= frameItem->PropertiesTab->_toffset_fld->value()+ frameItem->PropertiesTab->_height_fld->value())
			{
				selectedFrame=frameItem;
			}
		}
	}

	if(!selectedFrame)
	{
		// No selected frame, return
		return;
	}
	
	if(selectedFrame->frameType() == QP_TS)
	{	
		double tstart = selectedFrame->tAxisTab->_axis_time_fld->getStart().getEpoch2000();
		double tend = selectedFrame->tAxisTab->_axis_time_fld->getEnd().getEpoch2000();
		
		// look for min and max for all the objects in the frame
		
		double objtmin=tstart;
		double objtmax=tend;

		// now set up widget

		win->disconnect(SIGNAL(rescaleScalar(double, double)));
		win->disconnect(SIGNAL(rescaleTime(DvEvent)));
		
		connect(win, SIGNAL(rescaleTime(DvEvent)), selectedFrame->tAxisTab, SLOT(interactiveRescale(DvEvent)));
		
		win->intervalDialog->setWindowTitle(selectedFrame->TitleTab->_title_fld->text());
		win->intervalDialog->move(win->x()+win->plot->x()+pos_x-win->intervalDialog->width()/2,win->y()+win->plot->y()+pos_y);
		win->intervalDialog->setVisible(true);
		win->intervalDialog->resize(win->intervalDialog->minimumSizeHint());
		

		double fromMeta, toMeta;
		bool foundMeta = selectedFrame->getXmetaRange(fromMeta, toMeta);
		DvTime from, to;
		from=selectedFrame->tAxisTab->_axis_time_fld->getStart();
		to=selectedFrame->tAxisTab->_axis_time_fld->getEnd();


		if(foundMeta && !alreadyVisible)
		{
			win->intervalDialog->setViewRange(DvEvent(DvTime(fromMeta), DvTime(toMeta)));
			win->intervalDialog->setAsTimeInterval(from, to, selectedFrame);
			win->intervalDialog->setAvailabilityRange(fromMeta, toMeta);
		}
		win->intervalDialog->raise();
	}
	else if(selectedFrame->frameType()==QP_XY)
	{
		double xstart = selectedFrame->xAxisTab->_axis_xy_fld->getStart();
		double xend = selectedFrame->xAxisTab->_axis_xy_fld->getEnd();
		// look for min and max for all the objects in the frame
		

		// now set up widget

		win->disconnect(SIGNAL(rescaleScalar(double, double)));
		win->disconnect(SIGNAL(rescaleTime(DvEvent)));

		connect(win, SIGNAL(rescaleScalar(double, double)), selectedFrame->xAxisTab, SLOT(interactiveRescale(double, double)));
		
		win->intervalDialog->setWindowTitle(selectedFrame->TitleTab->_title_fld->text());
		win->intervalDialog->move(win->x()+win->plot->x()+pos_x-win->intervalDialog->width()/2,win->y()+win->plot->y()+pos_y);
		win->intervalDialog->setVisible(true);
		win->intervalDialog->resize(win->intervalDialog->minimumSizeHint());
				
		double fromMeta, toMeta;
		bool foundMeta = selectedFrame->getXmetaRange(fromMeta, toMeta);
		double from, to;
		from=selectedFrame->xAxisTab->_axis_xy_fld->getStart();
		to=selectedFrame->xAxisTab->_axis_xy_fld->getEnd();
		if(foundMeta && !alreadyVisible)
		{
			win->intervalDialog->setViewRange(fromMeta, toMeta);
			win->intervalDialog->setAsXInterval(from, to);
			win->intervalDialog->setAvailabilityRange(fromMeta, toMeta);
		}
		win->intervalDialog->resize(win->intervalDialog->minimumSizeHint());
		win->intervalDialog->setVisible(true);
		win->intervalDialog->raise();
	}
	
}





